package chessTrainingWheels;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.WindowConstants;

public class AboutDialog extends JDialog {
    /**
	 * Making Java warnings happy.
	 */
	private static final long serialVersionUID = 8533230102056440393L;
	private JLabel titleLabel;
    private JLabel descriptionLabel;
    private JButton OKButton;

    public AboutDialog(JFrame frame) {
        super(frame, true);
        initGUI();
    }
    
    private void initGUI() {
        try {

            GridBagLayout thisLayout = new GridBagLayout();
            getContentPane().setLayout(thisLayout);
            setTitle("About");
            setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

            titleLabel = new JLabel();
            getContentPane().add(titleLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
            titleLabel.setText("<html><h1>Chess Training Wheels 0.5</h1></html>");
            // titleLabel.setIcon(new ImageIcon(getClass().getResource("images/logo32.png")));
            titleLabel.setIconTextGap(10);

            descriptionLabel = new JLabel();
            getContentPane().add(descriptionLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));
            descriptionLabel.setText("<html>A graphical chess user interface with visualizations of the game status. <br>" +
                    "Copyright (C) 2007  Josh Weihnacht<br>" +
                    "<a href=\"http://www.inputpattern.com\">http://www.inputpattern.com</a></html>");

            OKButton = new JButton();
            getContentPane().add(OKButton, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
            OKButton.setText("OK");
            OKButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    AboutDialog.this.dispose();
                }
            });
            getRootPane().setDefaultButton(OKButton);
            
            pack();
            setLocationRelativeTo(getOwner());

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
