package chessTrainingWheels;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.WindowConstants;

public class IllegalMoveDialog extends JDialog {
    /**
	 * Making Java warnings happy.
	 */
	private static final long serialVersionUID = 810495362777521642L;
	
	private JLabel titleLabel;
    private JLabel descriptionLabel;
    private JButton OKButton;

    public IllegalMoveDialog(JFrame frame) {
        super(frame, true);
        initGUI();
    }
    
    private void initGUI() {
        try {

            GridBagLayout thisLayout = new GridBagLayout();
            getContentPane().setLayout(thisLayout);
            setTitle("About");
            setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

            titleLabel = new JLabel();
            getContentPane().add(titleLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
            titleLabel.setText("<html><h2>Illegal Move</h2></html>");
            // titleLabel.setIcon(new ImageIcon(getClass().getResource("images/logo32.png")));
            titleLabel.setIconTextGap(10);

            descriptionLabel = new JLabel();
            getContentPane().add(descriptionLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));
            descriptionLabel.setText("<html>" +
            		"Sorry, the computer opponent says that move is illegal.<br>" +
            		"The programmer of this interface did a bad job of checking <br>" +
            		"for illegal moves and you should blame him.<br>" +
            		"<br><br>" +
            		"You're last move will be undone and you can try again.</html>");

            OKButton = new JButton();
            getContentPane().add(OKButton, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
            OKButton.setText("OK");
            OKButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                	IllegalMoveDialog.this.dispose();
                }
            });
            getRootPane().setDefaultButton(OKButton);
            
            pack();
            setLocationRelativeTo(getOwner());

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
