/* This file is part of chessbox_gnu4j, a Java port of GNU Chess (5.0.7).

   Copyright (c) 2005 Xan Gregg (Java port)
   Copyright (c) 1999-2002 Free Software Foundation, Inc.

   chessbox_gnu4j is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 or (at your option)
   any later version.

   chessbox_gnu4j is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Chess; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info:
     bug-gnu-chess@gnu.org
     xan.gregg@pobox.com
*/
package org.chessbox.gnu4j;

import java.io.*;

/**
 * Created by Xan Gregg.
 * Date: Apr 23, 2005
 */
public class Debug {

    static final int MAX_DEBUG = 1000;
    static final String DEBUG_FILENAME = "gnu4j.debug.txt";

/* Default to stderr */
    static Writer debug_fd;

    static Writer dbg_open(String name) {
        //int flags = O_WRONLY | O_CREAT | O_APPEND;
        //int mode = 0777;

        if (name == null && DEBUG_FILENAME == null) {
            // no debugging
            debug_fd = null;
        } else {
            if (name == null) {
                name = DEBUG_FILENAME;

                try {
                    debug_fd = new FileWriter(name);
                } catch (IOException e) {
                    e.printStackTrace();
                    debug_fd = new OutputStreamWriter(System.err);
                }

            }
        }
        dbg_printf("--- Opening debug log ---\n");
        return debug_fd;
    }

    static int dbg_close() {
        /* We don't want to close stderr */
        if (debug_fd instanceof OutputStreamWriter) {
            return -1;
        }
        dbg_printf("--- Closing debug log ---\n");
        try {
            debug_fd.close();
            return 0;
        } catch (IOException e) {
            e.printStackTrace();
            return -1;
        }
    }

    static int dbg_printf(String s) {
        try {
            debug_fd.write(s);
            debug_fd.flush();
//            System.out.println("DEBUG: " + s);
            return 0;
        } catch (IOException e) {
            e.printStackTrace();
            return -1;
        }
//       va_list ap;
//       char buf[MAX_DEBUG];
//       struct timeval tv;
//
//       gettimeofday(&tv, NULL);
//       sprintf(buf, "%010ld.%06ld: ", tv.tv_sec, tv.tv_usec);
//       write(debug_fd, buf, strlen(buf));
//
//       va_start(ap, fmt);
//       vsnprintf(buf, MAX_DEBUG, fmt, ap);
//       va_end(ap);
//
//       return write(debug_fd, buf, strlen(buf));
    }

}
