/* This file is part of chessbox_gnu4j, a Java port of GNU Chess (5.0.7).

   Copyright (c) 2005 Xan Gregg (Java port)
   Copyright (c) 1999-2002 Free Software Foundation, Inc.

   chessbox_gnu4j is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 or (at your option)
   any later version.

   chessbox_gnu4j is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Chess; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info:
     bug-gnu-chess@gnu.org
     xan.gregg@pobox.com
*/
package org.chessbox.gnu4j;

/**
 * Created by Xan Gregg.
 * Date: Apr 22, 2005
 */
public class HashSlot {
    public /*HashType*/long key;    /* Full 64 bit hash */
    public int move;        /* Best move */
    public short score;       /* Estimated score, may be lower or upper bound */
    public byte flag;    /* Is this alpha, beta, quiescent or exact? */   // was uint8_t
    public byte depth;   /* Search depth */   // was uint8_t

    public void copy(HashSlot h) {
        key = h.key;
        move = h.move;
        score = h.score;
        flag = h.flag;
        depth = h.depth;
    }
}
