/* This file is part of chessbox_gnu4j, a Java port of GNU Chess (5.0.7).

   Copyright (c) 2005 Xan Gregg (Java port)
   Copyright (c) 1999-2002 Free Software Foundation, Inc.

   chessbox_gnu4j is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 or (at your option)
   any later version.

   chessbox_gnu4j is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Chess; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info:
     bug-gnu-chess@gnu.org
     xan.gregg@pobox.com
*/
package org.chessbox.gnu4j;

/**
 * Created by Xan Gregg.
 * Date: May 8, 2005
 */
public class Hung extends Common {

    /**
     * Calculates the number of hung pieces for a side.
     */
    static int EvalHung(int side) {
        /*BitBoard*/long c, n, b, r, q;
        int xside;

        xside = 1 ^ side;
        hunged[side] = 0;

        /* Knight */
        n = (Ataks[xside][pawn] & board.b[side][knight]);
        n |= (Ataks[xside][0] & board.b[side][knight] & ~Ataks[side][0]);

        /* Bishop */
        b = (Ataks[xside][pawn] & board.b[side][bishop]);
        b |= (Ataks[xside][0] & board.b[side][bishop] & ~Ataks[side][0]);

        /* Rook */
        r = Ataks[xside][pawn] | Ataks[xside][knight] | Ataks[xside][bishop];
        r = (r & board.b[side][rook]);
        r |= (Ataks[xside][0] & board.b[side][rook] & ~Ataks[side][0]);

        /* Queen */
        q = Ataks[xside][pawn] | Ataks[xside][knight] | Ataks[xside][bishop] |
                Ataks[xside][rook];
        q = (q & board.b[side][queen]);
        q |= (Ataks[xside][0] & board.b[side][queen] & ~Ataks[side][0]);

        c = n | b | r | q;

        if (c != 0)
            hunged[side] += Util.nbits(c);

        /* King */
        if ((Atak.Ataks[xside][0] & board.b[side][king]) != 0)
            hunged[side]++;

        return (hunged[side]);
    }
}
