/* This file is part of chessbox_gnu4j, a Java port of GNU Chess (5.0.7).

   Copyright (c) 2005 Xan Gregg (Java port)
   Copyright (c) 1999-2002 Free Software Foundation, Inc.

   chessbox_gnu4j is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 or (at your option)
   any later version.

   chessbox_gnu4j is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Chess; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info:
     bug-gnu-chess@gnu.org
     xan.gregg@pobox.com
*/
package org.chessbox.gnu4j;

/**
 * leaf describes a leaf-level analysis result
 *
 * Created by Xan Gregg.
 * Date: Apr 22, 2005
 */
@SuppressWarnings("all")
public class Leaf implements Comparable {
    public int move;   /* the move that produced this particular board */
    public int score;  /* the scored value of this leaf */

    public int compareTo(Object o) {
        Leaf a = this;
        Leaf b = (Leaf) o;
        if (b.score > a.score) return(1);
        else if (b.score < a.score) return(-1);
        else return(0);
    }

    public void swap(Leaf other) {
        int m = move;
        move = other.move;
        other.move = m;
        int s = score;
        score = other.score;
        other.score = s;
    }


    public String toString() {
        return Move.AlgbrMove(move) + " => " + score;
    }

    public void copy(Leaf other) {
        move = other.move;
        score = other.score;
    }
}
