/* This file is part of chessbox_gnu4j, a Java port of GNU Chess (5.0.7).

   Copyright (c) 2005 Xan Gregg (Java port)
   Copyright (c) 1999-2002 Free Software Foundation, Inc.

   chessbox_gnu4j is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 or (at your option)
   any later version.

   chessbox_gnu4j is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Chess; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info:
     bug-gnu-chess@gnu.org
     xan.gregg@pobox.com
*/
package org.chessbox.gnu4j;

import java.io.*;

/**
 * Created by Xan Gregg.
 * Date: Apr 26, 2005
 */
public class LexPGN extends Common {
/* A lexical scanner generated by flex */

    static final int FLEX_SCANNER = 1;
    static final int YY_FLEX_MAJOR_VERSION = 2;
    static final int YY_FLEX_MINOR_VERSION = 5;


/* Returned upon end-of-file. */
    static final int YY_NULL = 0;

    static final int EOF = 0;   // fixjava (can't find EOF in C code)

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
    static int YY_SC_TO_UI(int c) {return c & 0xff;}

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
    static void BEGIN(int n) {yy_start = 1 + 2 * n;}

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
    static int YY_START() { return ((yy_start - 1) / 2);}

    static int YYSTATE() { return YY_START(); }

/* Action number for EOF rule of a given start state. */
    static int YY_STATE_EOF(int state) { return (YY_END_OF_BUFFER + state + 1);}

/* Special action meaning "start processing a new file". */
    static void YY_NEW_FILE() { yyrestart(yyin); }

    static final int YY_END_OF_BUFFER_CHAR = 0;

/* Size of default input buffer. */
    static final int YY_BUF_SIZE = 16384;

    static int yyleng;
    static Reader yyin;
    static Writer yyout;

    static final int EOB_ACT_CONTINUE_SCAN = 0;
    static final int EOB_ACT_END_OF_FILE = 1;
    static final int EOB_ACT_LAST_MATCH = 2;

/* Return all but the first 'n' matched characters back to the input stream. */

    static int yyless(int bp, int cp, int n) {
        /* Undo effects of setting up yytext. */
        //  yytext[cp] = yy_hold_char;
        YY_RESTORE_YY_MORE_OFFSET();
        yy_c_buf_p = cp = bp + n - YY_MORE_ADJ;
        YY_DO_BEFORE_ACTION(bp, cp); /* set up yytext again */
        return cp;
    }

    static void unput(int c) { yyunput(c, yytext_ptr); }

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
//    typedef unsigned int yy_size_t;

    static final int YY_BUFFER_NEW = 0;
    static final int YY_BUFFER_NORMAL = 1;
    /* When an EOF's been seen but there's still some text to process
     * then we mark the buffer as YY_EOF_PENDING, to indicate that we
     * shouldn't try reading from the input source any more.  We might
     * still have a bunch of tokens to match, though, because of
     * possible backing-up.
     *
     * When we actually see the EOF, we change the status to "new"
     * (via yyrestart()), so that the user can continue scanning by
     * just pointing yyin at a new input file.
     */
    static final int YY_BUFFER_EOF_PENDING = 2;

    static class YY_BUFFER_STATE {
        Reader yy_input_file;    // FILE *

        char[] yy_ch_buf;		/* input buffer */  // char*
        int yy_buf_pos;		/* current position in input buffer */  // char*

        /* Size of input buffer in bytes, not including room for EOB
         * characters.
         */
        int yy_buf_size;

        /* Number of characters read into yy_ch_buf, not including EOB
         * characters.
         */
        int yy_n_chars;

        /* Whether we "own" the buffer - i.e., we know we created it,
         * and can realloc() it to grow it, and should free() it to
         * delete it.
         */
        boolean yy_is_our_buffer;

        /* Whether this is an "interactive" input source; if so, and
         * if we're using stdio for input, then we want to use getc()
         * instead of fread(), to make sure we stop fetching input after
         * each newline.
         */
        boolean yy_is_interactive;

        /* Whether we're considered to be at the beginning of a line.
         * If so, '^' rules will be active on the next match, otherwise
         * not.
         */
        boolean yy_at_bol;

        /* Whether to try to fill the input buffer when we reach the
         * end of it.
         */
        boolean yy_fill_buffer;

        int yy_buffer_status;
    };

    static YY_BUFFER_STATE yy_current_buffer = null;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
    static YY_BUFFER_STATE YY_CURRENT_BUFFER() { return yy_current_buffer; }


/* yy_hold_char holds the character lost when yytext is formed. */
    static char yy_hold_char;

    static int yy_n_chars;		/* number of characters read into yy_ch_buf */

/* Points to current character in buffer. */
    static int yy_c_buf_p = 0;  // char*
    static boolean yy_init = true;		/* whether we need to initialize */
    static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
    static boolean yy_did_buffer_switch_on_eof;

    static void YY_FLUSH_BUFFER() { yy_flush_buffer(yy_current_buffer);}

    static YY_BUFFER_STATE yy_new_buffer(Reader file, int size) {return yy_create_buffer(file, size);}

    static void yy_set_interactive(boolean is_interactive) {
        if (yy_current_buffer == null)
            yy_current_buffer = yy_create_buffer(yyin, YY_BUF_SIZE);
        yy_current_buffer.yy_is_interactive = is_interactive;
    }

    static void yy_set_bol(boolean at_bol) {
        if (yy_current_buffer == null)
            yy_current_buffer = yy_create_buffer(yyin, YY_BUF_SIZE);
        yy_current_buffer.yy_at_bol = at_bol;
    }

    static boolean YY_AT_BOL() { return (yy_current_buffer.yy_at_bol);}


    static boolean yywrap() {return true;}
    ///#define YY_SKIP_YYWRAP
    //typedef unsigned char YY_CHAR;

    // typedef int yy_state_type;
    //static char[] yytext;   // extern char*
    static int yytext_ptr = 0;

    static int[][] yy_nxt = // short[][46]
            {
                {
                    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0, 0
                },

                {
                    17, 18, 19, 20, 19, 19, 18, 18, 21, 22,
                    23, 18, 24, 18, 25, 18, 26, 27, 28, 28,
                    29, 30, 18, 18, 18, 31, 31, 31, 31, 31,
                    31, 31, 31, 31, 31, 31, 31, 31, 31, 31,
                    31, 31, 31, 31, 32, 18

                },

                {
                    17, 18, 19, 20, 19, 19, 18, 18, 21, 22,
                    23, 18, 24, 18, 25, 18, 26, 27, 28, 28,
                    29, 30, 18, 18, 18, 31, 31, 31, 31, 31,
                    31, 31, 31, 31, 31, 31, 31, 31, 31, 31,
                    31, 31, 31, 31, 32, 18
                },

                {
                    17, 33, 33, 34, 33, 34, 33, 33, 33, 33,
                    33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
                    33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
                    33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
                    33, 33, 33, 33, 33, 33

                },

                {
                    17, 33, 33, 34, 33, 34, 33, 33, 33, 33,
                    33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
                    33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
                    33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
                    33, 33, 33, 33, 33, 33
                },

                {
                    17, 35, 36, 37, 35, 38, 35, 35, 35, 35,
                    35, 35, 35, 35, 35, 35, 39, 39, 39, 39,
                    35, 35, 35, 40, 39, 39, 41, 39, 42, 43,
                    44, 39, 39, 39, 39, 39, 39, 39, 45, 46,
                    39, 39, 39, 47, 35, 35

                },

                {
                    17, 35, 36, 37, 35, 38, 35, 35, 35, 35,
                    35, 35, 35, 35, 35, 35, 39, 39, 39, 39,
                    35, 35, 35, 40, 39, 39, 41, 39, 42, 43,
                    44, 39, 39, 39, 39, 39, 39, 39, 45, 46,
                    39, 39, 39, 47, 35, 35
                },

                {
                    17, 48, 49, 34, 48, 48, 48, 48, 48, 48,
                    48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
                    48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
                    48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
                    48, 48, 48, 48, 48, 48

                },

                {
                    17, 48, 49, 34, 48, 48, 48, 48, 48, 48,
                    48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
                    48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
                    48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
                    48, 48, 48, 48, 48, 48
                },

                {
                    17, 50, 50, 51, 50, 52, 50, 53, 50, 50,
                    50, 50, 50, 50, 50, 50, 50, 50, 50, 50,
                    50, 50, 54, 50, 50, 50, 50, 50, 50, 50,
                    50, 50, 50, 50, 50, 50, 50, 50, 50, 50,
                    50, 50, 50, 50, 50, 50

                },

                {
                    17, 50, 50, 51, 50, 52, 50, 53, 50, 50,
                    50, 50, 50, 50, 50, 50, 50, 50, 50, 50,
                    50, 50, 54, 50, 50, 50, 50, 50, 50, 50,
                    50, 50, 50, 50, 50, 50, 50, 50, 50, 50,
                    50, 50, 50, 50, 50, 50
                },

                {
                    17, 55, 55, 34, 55, 34, 55, 55, 55, 55,
                    55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
                    55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
                    55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
                    55, 55, 55, 55, 55, 55

                },

                {
                    17, 55, 55, 34, 55, 34, 55, 55, 55, 55,
                    55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
                    55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
                    55, 55, 55, 55, 55, 55, 55, 55, 55, 55,
                    55, 55, 55, 55, 55, 55
                },

                {
                    17, 56, 56, 57, 56, 58, 56, 56, 56, 56,
                    56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
                    56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
                    56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
                    56, 56, 56, 56, 56, 59

                },

                {
                    17, 56, 56, 57, 56, 58, 56, 56, 56, 56,
                    56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
                    56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
                    56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
                    56, 56, 56, 56, 56, 59
                },

                {
                    17, 60, 60, 60, 60, 60, 60, 60, 60, 60,
                    61, 62, 60, 60, 60, 60, 60, 60, 60, 60,
                    60, 63, 60, 60, 60, 60, 60, 60, 60, 60,
                    60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
                    60, 60, 60, 60, 60, 60

                },

                {
                    17, 60, 60, 60, 60, 60, 60, 60, 60, 60,
                    61, 62, 60, 60, 60, 60, 60, 60, 60, 60,
                    60, 64, 60, 60, 60, 60, 60, 60, 60, 60,
                    60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
                    60, 60, 60, 60, 60, 60
                },

                {
                    -17, -17, -17, -17, -17, -17, -17, -17, -17, -17,
                    -17, -17, -17, -17, -17, -17, -17, -17, -17, -17,
                    -17, -17, -17, -17, -17, -17, -17, -17, -17, -17,
                    -17, -17, -17, -17, -17, -17, -17, -17, -17, -17,
                    -17, -17, -17, -17, -17, -17

                },

                {
                    17, -18, -18, -18, -18, -18, -18, -18, -18, -18,
                    -18, -18, -18, -18, -18, -18, -18, -18, -18, -18,
                    -18, -18, -18, -18, -18, -18, -18, -18, -18, -18,
                    -18, -18, -18, -18, -18, -18, -18, -18, -18, -18,
                    -18, -18, -18, -18, -18, -18
                },

                {
                    17, -19, 65, 65, 65, 65, -19, -19, -19, -19,
                    -19, -19, -19, -19, -19, -19, -19, -19, -19, -19,
                    -19, -19, -19, -19, -19, -19, -19, -19, -19, -19,
                    -19, -19, -19, -19, -19, -19, -19, -19, -19, -19,
                    -19, -19, -19, -19, -19, -19

                },

                {
                    17, -20, 65, 65, 65, 65, -20, -20, -20, -20,
                    -20, -20, -20, -20, -20, -20, -20, -20, -20, -20,
                    -20, -20, -20, -20, -20, -20, -20, -20, -20, -20,
                    -20, -20, -20, -20, -20, -20, -20, -20, -20, -20,
                    -20, -20, -20, -20, -20, -20
                },

                {
                    17, 66, -21, -21, -21, -21, 66, 66, 66, 66,
                    66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
                    66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
                    66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
                    66, 66, 66, 66, 66, 66

                },

                {
                    17, 67, 67, -22, 67, -22, 67, 67, 67, 67,
                    67, 67, 67, 67, 67, 67, 67, 67, 67, 67,
                    67, 67, 67, 67, 67, 67, 67, 67, 67, 67,
                    67, 67, 67, 67, 67, 67, 67, 67, 67, 67,
                    67, 67, 67, 67, 67, 67
                },

                {
                    17, -23, -23, -23, -23, -23, -23, -23, -23, -23,
                    -23, -23, -23, -23, -23, -23, -23, -23, -23, -23,
                    -23, -23, -23, -23, -23, -23, -23, -23, -23, -23,
                    -23, -23, -23, -23, -23, -23, -23, -23, -23, -23,
                    -23, -23, -23, -23, -23, -23

                },

                {
                    17, -24, 68, 68, 68, 68, -24, -24, -24, -24,
                    -24, -24, -24, -24, -24, -24, -24, -24, -24, -24,
                    -24, -24, -24, -24, -24, -24, -24, -24, -24, -24,
                    -24, -24, -24, -24, -24, -24, -24, -24, -24, -24,
                    -24, -24, -24, -24, -24, -24
                },

                {
                    17, -25, -25, -25, -25, -25, -25, -25, -25, -25,
                    -25, -25, -25, -25, 69, -25, -25, -25, -25, -25,
                    -25, -25, -25, -25, -25, -25, -25, -25, -25, -25,
                    -25, -25, -25, -25, -25, -25, -25, -25, -25, -25,
                    -25, -25, -25, -25, -25, -25

                },

                {
                    17, -26, -26, -26, -26, -26, 70, -26, -26, -26,
                    -26, -26, -26, 71, -26, -26, 70, 70, 70, 70,
                    -26, -26, -26, -26, -26, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, 70, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, -26, -26
                },

                {
                    17, -27, -27, -27, -27, -27, -27, -27, -27, -27,
                    -27, -27, -27, 72, 73, 74, 75, 75, 75, 75,
                    -27, -27, -27, -27, -27, -27, -27, -27, -27, -27,
                    -27, -27, -27, -27, -27, -27, -27, -27, -27, -27,
                    -27, -27, -27, -27, -27, -27

                },

                {
                    17, -28, -28, -28, -28, -28, -28, -28, -28, -28,
                    -28, -28, -28, -28, 73, -28, 75, 75, 75, 75,
                    -28, -28, -28, -28, -28, -28, -28, -28, -28, -28,
                    -28, -28, -28, -28, -28, -28, -28, -28, -28, -28,
                    -28, -28, -28, -28, -28, -28
                },

                {
                    17, 76, 76, -29, 76, -29, 76, 76, 76, 76,
                    76, 76, 76, 76, 76, 76, 76, 76, 76, 76,
                    76, 76, 76, 76, 76, 76, 76, 76, 76, 76,
                    76, 76, 76, 76, 76, 76, 76, 76, 76, 76,
                    76, 76, 76, 76, 76, 76

                },

                {
                    17, -30, 77, -30, -30, -30, -30, -30, -30, -30,
                    -30, -30, -30, -30, -30, -30, -30, -30, -30, -30,
                    -30, -30, -30, -30, -30, -30, -30, -30, -30, -30,
                    -30, -30, -30, -30, -30, -30, -30, -30, -30, -30,
                    -30, -30, -30, -30, -30, -30
                },

                {
                    17, -31, -31, -31, -31, -31, 70, -31, -31, -31,
                    -31, -31, -31, 70, -31, -31, 70, 70, 70, 70,
                    -31, -31, -31, -31, -31, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, 70, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, -31, -31

                },

                {
                    17, -32, -32, -32, -32, -32, -32, -32, -32, -32,
                    -32, -32, -32, -32, -32, -32, -32, -32, -32, -32,
                    -32, -32, -32, -32, -32, -32, -32, -32, -32, -32,
                    -32, -32, -32, -32, -32, -32, -32, -32, -32, -32,
                    -32, -32, -32, -32, -32, -32
                },

                {
                    17, 78, 78, -33, 78, -33, 78, 78, 78, 78,
                    78, 78, 78, 78, 78, 78, 78, 78, 78, 78,
                    78, 78, 78, 78, 78, 78, 78, 78, 78, 78,
                    78, 78, 78, 78, 78, 78, 78, 78, 78, 78,
                    78, 78, 78, 78, 78, 78

                },

                {
                    17, -34, -34, -34, -34, -34, -34, -34, -34, -34,
                    -34, -34, -34, -34, -34, -34, -34, -34, -34, -34,
                    -34, -34, -34, -34, -34, -34, -34, -34, -34, -34,
                    -34, -34, -34, -34, -34, -34, -34, -34, -34, -34,
                    -34, -34, -34, -34, -34, -34
                },

                {
                    17, -35, -35, -35, -35, -35, -35, -35, -35, -35,
                    -35, -35, -35, -35, -35, -35, -35, -35, -35, -35,
                    -35, -35, -35, -35, -35, -35, -35, -35, -35, -35,
                    -35, -35, -35, -35, -35, -35, -35, -35, -35, -35,
                    -35, -35, -35, -35, -35, -35

                },

                {
                    17, -36, 79, -36, -36, -36, -36, -36, -36, -36,
                    -36, -36, -36, -36, -36, -36, -36, -36, -36, -36,
                    -36, -36, -36, 80, -36, -36, -36, -36, -36, -36,
                    -36, -36, -36, -36, -36, -36, -36, -36, -36, -36,
                    -36, -36, -36, -36, -36, -36
                },

                {
                    17, -37, -37, -37, -37, -37, -37, -37, -37, -37,
                    -37, -37, -37, -37, -37, -37, -37, -37, -37, -37,
                    -37, -37, -37, -37, -37, -37, -37, -37, -37, -37,
                    -37, -37, -37, -37, -37, -37, -37, -37, -37, -37,
                    -37, -37, -37, -37, -37, -37

                },

                {
                    17, -38, -38, -38, -38, -38, -38, -38, -38, -38,
                    -38, -38, -38, -38, -38, -38, -38, -38, -38, -38,
                    -38, -38, -38, -38, -38, -38, -38, -38, -38, -38,
                    -38, -38, -38, -38, -38, -38, -38, -38, -38, -38,
                    -38, -38, -38, -38, -38, -38
                },

                {
                    17, -39, -39, -39, -39, -39, -39, -39, -39, -39,
                    -39, -39, -39, -39, -39, -39, 81, 81, 81, 81,
                    -39, -39, -39, -39, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -39, -39

                },

                {
                    17, -40, -40, -40, -40, -40, -40, -40, -40, -40,
                    -40, -40, -40, -40, -40, -40, -40, -40, -40, -40,
                    -40, -40, -40, -40, -40, -40, -40, -40, -40, -40,
                    -40, -40, -40, -40, -40, -40, -40, -40, -40, -40,
                    -40, -40, -40, -40, -40, -40
                },

                {
                    17, -41, -41, -41, -41, -41, -41, -41, -41, -41,
                    -41, -41, -41, -41, -41, -41, 81, 81, 81, 81,
                    -41, -41, -41, -41, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 82, 81, 81, 81, 81,
                    81, 81, 81, 81, -41, -41

                },

                {
                    17, -42, -42, -42, -42, -42, -42, -42, -42, -42,
                    -42, -42, -42, -42, -42, -42, 81, 81, 81, 81,
                    -42, -42, -42, -42, 81, 83, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -42, -42
                },

                {
                    17, -43, -43, -43, -43, -43, -43, -43, -43, -43,
                    -43, -43, -43, -43, -43, -43, 81, 81, 81, 81,
                    -43, -43, -43, -43, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 84, 81, -43, -43

                },

                {
                    17, -44, -44, -44, -44, -44, -44, -44, -44, -44,
                    -44, -44, -44, -44, -44, -44, 81, 81, 81, 81,
                    -44, -44, -44, -44, 81, 81, 81, 81, 81, 85,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -44, -44
                },

                {
                    17, -45, -45, -45, -45, -45, -45, -45, -45, -45,
                    -45, -45, -45, -45, -45, -45, 81, 81, 81, 81,
                    -45, -45, -45, -45, 81, 81, 81, 81, 81, 86,
                    81, 81, 81, 81, 81, 81, 81, 87, 81, 81,
                    81, 81, 81, 81, -45, -45

                },

                {
                    17, -46, -46, -46, -46, -46, -46, -46, -46, -46,
                    -46, -46, -46, -46, -46, -46, 81, 81, 81, 81,
                    -46, -46, -46, -46, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 88, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -46, -46
                },

                {
                    17, -47, -47, -47, -47, -47, -47, -47, -47, -47,
                    -47, -47, -47, -47, -47, -47, 81, 81, 81, 81,
                    -47, -47, -47, -47, 81, 81, 81, 81, 81, 81,
                    81, 81, 89, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -47, -47

                },

                {
                    17, -48, -48, -48, -48, -48, -48, -48, -48, -48,
                    -48, -48, -48, -48, -48, -48, -48, -48, -48, -48,
                    -48, -48, -48, -48, -48, -48, -48, -48, -48, -48,
                    -48, -48, -48, -48, -48, -48, -48, -48, -48, -48,
                    -48, -48, -48, -48, -48, -48
                },

                {
                    17, -49, 90, -49, -49, -49, -49, 91, -49, -49,
                    -49, -49, -49, -49, -49, -49, -49, -49, -49, -49,
                    -49, -49, -49, -49, -49, -49, -49, -49, -49, -49,
                    -49, -49, -49, -49, -49, -49, -49, -49, -49, -49,
                    -49, -49, -49, -49, -49, -49

                },

                {
                    17, 92, 92, -50, 92, -50, 92, -50, 92, 92,
                    92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 93, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92
                },

                {
                    17, -51, -51, -51, -51, -51, -51, -51, -51, -51,
                    -51, -51, -51, -51, -51, -51, -51, -51, -51, -51,
                    -51, -51, -51, -51, -51, -51, -51, -51, -51, -51,
                    -51, -51, -51, -51, -51, -51, -51, -51, -51, -51,
                    -51, -51, -51, -51, -51, -51

                },

                {
                    17, -52, -52, -52, -52, -52, -52, -52, -52, -52,
                    -52, -52, -52, -52, -52, -52, -52, -52, -52, -52,
                    -52, -52, -52, -52, -52, -52, -52, -52, -52, -52,
                    -52, -52, -52, -52, -52, -52, -52, -52, -52, -52,
                    -52, -52, -52, -52, -52, -52
                },

                {
                    17, 94, 95, -53, 94, -53, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 96, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94

                },

                {
                    17, 92, 92, -54, 92, -54, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 93, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92
                },

                {
                    17, 97, 97, -55, 97, -55, 97, 97, 97, 97,
                    97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
                    97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
                    97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
                    97, 97, 97, 97, 97, 97

                },

                {
                    17, 98, 98, 99, 98, -56, 98, 98, 98, 98,
                    98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
                    98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
                    98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
                    98, 98, 98, 98, 98, -56
                },

                {
                    17, -57, -57, -57, -57, 100, -57, -57, -57, -57,
                    -57, -57, -57, -57, -57, -57, -57, -57, -57, -57,
                    -57, -57, -57, -57, -57, -57, -57, -57, -57, -57,
                    -57, -57, -57, -57, -57, -57, -57, -57, -57, -57,
                    -57, -57, -57, -57, -57, -57

                },

                {
                    17, -58, -58, 101, -58, -58, -58, -58, -58, -58,
                    -58, -58, -58, -58, -58, -58, -58, -58, -58, -58,
                    -58, -58, -58, -58, -58, -58, -58, -58, -58, -58,
                    -58, -58, -58, -58, -58, -58, -58, -58, -58, -58,
                    -58, -58, -58, -58, -58, -58
                },

                {
                    17, -59, -59, -59, -59, -59, -59, -59, -59, -59,
                    -59, -59, -59, -59, -59, -59, -59, -59, -59, -59,
                    -59, -59, -59, -59, -59, -59, -59, -59, -59, -59,
                    -59, -59, -59, -59, -59, -59, -59, -59, -59, -59,
                    -59, -59, -59, -59, -59, -59

                },

                {
                    17, 102, 102, 102, 102, 102, 102, 102, 102, 102,
                    -60, -60, 102, 102, 102, 102, 102, 102, 102, 102,
                    102, -60, 102, 102, 102, 102, 102, 102, 102, 102,
                    102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
                    102, 102, 102, 102, 102, 102
                },

                {
                    17, -61, -61, -61, -61, -61, -61, -61, -61, -61,
                    -61, -61, -61, -61, -61, -61, -61, -61, -61, -61,
                    -61, -61, -61, -61, -61, -61, -61, -61, -61, -61,
                    -61, -61, -61, -61, -61, -61, -61, -61, -61, -61,
                    -61, -61, -61, -61, -61, -61

                },

                {
                    17, -62, -62, -62, -62, -62, -62, -62, -62, -62,
                    -62, -62, -62, -62, -62, -62, -62, -62, -62, -62,
                    -62, -62, -62, -62, -62, -62, -62, -62, -62, -62,
                    -62, -62, -62, -62, -62, -62, -62, -62, -62, -62,
                    -62, -62, -62, -62, -62, -62
                },

                {
                    17, -63, -63, -63, -63, -63, -63, -63, -63, -63,
                    -63, -63, -63, -63, -63, -63, -63, -63, -63, -63,
                    -63, -63, -63, -63, -63, -63, -63, -63, -63, -63,
                    -63, -63, -63, -63, -63, -63, -63, -63, -63, -63,
                    -63, -63, -63, -63, -63, -63

                },

                {
                    17, -64, -64, -64, -64, -64, -64, -64, -64, -64,
                    -64, -64, -64, -64, -64, -64, -64, -64, -64, -64,
                    -64, -64, -64, -64, -64, -64, -64, -64, -64, -64,
                    -64, -64, -64, -64, -64, -64, -64, -64, -64, -64,
                    -64, -64, -64, 103, -64, -64
                },

                {
                    17, -65, 65, 65, 65, 65, -65, -65, -65, -65,
                    -65, -65, -65, -65, -65, -65, -65, -65, -65, -65,
                    -65, -65, -65, -65, -65, -65, -65, -65, -65, -65,
                    -65, -65, -65, -65, -65, -65, -65, -65, -65, -65,
                    -65, -65, -65, -65, -65, -65

                },

                {
                    17, 66, -66, -66, -66, -66, 66, 66, 66, 66,
                    66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
                    66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
                    66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
                    66, 66, 66, 66, 66, 66
                },

                {
                    17, 67, 67, -67, 67, -67, 67, 67, 67, 67,
                    67, 67, 67, 67, 67, 67, 67, 67, 67, 67,
                    67, 67, 67, 67, 67, 67, 67, 67, 67, 67,
                    67, 67, 67, 67, 67, 67, 67, 67, 67, 67,
                    67, 67, 67, 67, 67, 67

                },

                {
                    17, -68, 68, 68, 68, 68, -68, -68, -68, -68,
                    -68, -68, -68, -68, -68, -68, -68, -68, -68, -68,
                    -68, -68, -68, -68, -68, -68, -68, -68, -68, -68,
                    -68, -68, -68, -68, -68, -68, -68, -68, -68, -68,
                    -68, -68, -68, -68, -68, -68
                },

                {
                    17, -69, -69, -69, -69, -69, -69, -69, -69, -69,
                    -69, -69, -69, -69, 69, -69, -69, -69, -69, -69,
                    -69, -69, -69, -69, -69, -69, -69, -69, -69, -69,
                    -69, -69, -69, -69, -69, -69, -69, -69, -69, -69,
                    -69, -69, -69, -69, -69, -69

                },

                {
                    17, -70, -70, -70, -70, -70, 70, -70, -70, -70,
                    -70, -70, -70, 70, -70, -70, 70, 70, 70, 70,
                    -70, -70, -70, -70, -70, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, 70, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, -70, -70
                },

                {
                    17, -71, -71, -71, -71, -71, 70, -71, -71, -71,
                    -71, -71, -71, 70, -71, -71, 70, 104, 70, 70,
                    -71, -71, -71, -71, -71, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, 70, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, -71, -71

                },

                {
                    17, -72, -72, -72, -72, -72, -72, -72, -72, -72,
                    -72, -72, -72, -72, -72, -72, 105, -72, -72, -72,
                    -72, -72, -72, -72, -72, -72, -72, -72, -72, -72,
                    -72, -72, -72, -72, -72, -72, -72, -72, -72, -72,
                    -72, -72, -72, -72, -72, -72
                },

                {
                    17, -73, -73, -73, -73, -73, -73, -73, -73, -73,
                    -73, -73, -73, -73, -73, -73, -73, -73, -73, -73,
                    -73, -73, -73, -73, -73, -73, -73, -73, -73, -73,
                    -73, -73, -73, -73, -73, -73, -73, -73, -73, -73,
                    -73, -73, -73, -73, -73, -73

                },

                {
                    17, -74, -74, -74, -74, -74, -74, -74, -74, -74,
                    -74, -74, -74, -74, -74, -74, -74, -74, 106, -74,
                    -74, -74, -74, -74, -74, -74, -74, -74, -74, -74,
                    -74, -74, -74, -74, -74, -74, -74, -74, -74, -74,
                    -74, -74, -74, -74, -74, -74
                },

                {
                    17, -75, -75, -75, -75, -75, -75, -75, -75, -75,
                    -75, -75, -75, -75, 73, -75, 75, 75, 75, 75,
                    -75, -75, -75, -75, -75, -75, -75, -75, -75, -75,
                    -75, -75, -75, -75, -75, -75, -75, -75, -75, -75,
                    -75, -75, -75, -75, -75, -75

                },

                {
                    17, 76, 76, -76, 76, -76, 76, 76, 76, 76,
                    76, 76, 76, 76, 76, 76, 76, 76, 76, 76,
                    76, 76, 76, 76, 76, 76, 76, 76, 76, 76,
                    76, 76, 76, 76, 76, 76, 76, 76, 76, 76,
                    76, 76, 76, 76, 76, 76
                },

                {
                    17, -77, 77, -77, -77, -77, -77, -77, -77, -77,
                    -77, -77, -77, -77, -77, -77, -77, -77, -77, -77,
                    -77, -77, -77, -77, -77, -77, -77, -77, -77, -77,
                    -77, -77, -77, -77, -77, -77, -77, -77, -77, -77,
                    -77, -77, -77, -77, -77, -77

                },

                {
                    17, 78, 78, -78, 78, -78, 78, 78, 78, 78,
                    78, 78, 78, 78, 78, 78, 78, 78, 78, 78,
                    78, 78, 78, 78, 78, 78, 78, 78, 78, 78,
                    78, 78, 78, 78, 78, 78, 78, 78, 78, 78,
                    78, 78, 78, 78, 78, 78
                },

                {
                    17, -79, 79, -79, -79, -79, -79, -79, -79, -79,
                    -79, -79, -79, -79, -79, -79, -79, -79, -79, -79,
                    -79, -79, -79, 80, -79, -79, -79, -79, -79, -79,
                    -79, -79, -79, -79, -79, -79, -79, -79, -79, -79,
                    -79, -79, -79, -79, -79, -79

                },

                {
                    17, -80, -80, -80, -80, -80, -80, -80, -80, -80,
                    -80, -80, -80, -80, -80, -80, -80, -80, -80, -80,
                    -80, -80, -80, -80, -80, -80, -80, -80, -80, -80,
                    -80, -80, -80, -80, -80, -80, -80, -80, -80, -80,
                    -80, -80, -80, -80, -80, -80
                },

                {
                    17, -81, -81, -81, -81, -81, -81, -81, -81, -81,
                    -81, -81, -81, -81, -81, -81, 81, 81, 81, 81,
                    -81, -81, -81, -81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -81, -81

                },

                {
                    17, -82, -82, -82, -82, -82, -82, -82, -82, -82,
                    -82, -82, -82, -82, -82, -82, 81, 81, 81, 81,
                    -82, -82, -82, -82, 81, 107, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -82, -82
                },

                {
                    17, -83, -83, -83, -83, -83, -83, -83, -83, -83,
                    -83, -83, -83, -83, -83, -83, 81, 81, 81, 81,
                    -83, -83, -83, -83, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    108, 81, 81, 81, -83, -83

                },

                {
                    17, -84, -84, -84, -84, -84, -84, -84, -84, -84,
                    -84, -84, -84, -84, -84, -84, 81, 81, 81, 81,
                    -84, -84, -84, -84, 81, 81, 81, 81, 81, 109,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -84, -84
                },

                {
                    17, -85, -85, -85, -85, -85, -85, -85, -85, -85,
                    -85, -85, -85, -85, -85, -85, 81, 81, 81, 81,
                    -85, -85, -85, -85, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 110, 81, 81, 81,
                    81, 81, 81, 81, -85, -85

                },

                {
                    17, -86, -86, -86, -86, -86, -86, -86, -86, -86,
                    -86, -86, -86, -86, -86, -86, 81, 81, 81, 81,
                    -86, -86, -86, -86, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 111,
                    81, 81, 81, 81, -86, -86
                },

                {
                    17, -87, -87, -87, -87, -87, -87, -87, -87, -87,
                    -87, -87, -87, -87, -87, -87, 81, 81, 81, 81,
                    -87, -87, -87, -87, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 112, 81, 81, -87, -87

                },

                {
                    17, -88, -88, -88, -88, -88, -88, -88, -88, -88,
                    -88, -88, -88, -88, -88, -88, 81, 81, 81, 81,
                    -88, -88, -88, -88, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    113, 81, 81, 81, -88, -88
                },

                {
                    17, -89, -89, -89, -89, -89, -89, -89, -89, -89,
                    -89, -89, -89, -89, -89, -89, 81, 81, 81, 81,
                    -89, -89, -89, -89, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 114, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -89, -89

                },

                {
                    17, -90, 90, -90, -90, -90, -90, 91, -90, -90,
                    -90, -90, -90, -90, -90, -90, -90, -90, -90, -90,
                    -90, -90, -90, -90, -90, -90, -90, -90, -90, -90,
                    -90, -90, -90, -90, -90, -90, -90, -90, -90, -90,
                    -90, -90, -90, -90, -90, -90
                },

                {
                    17, -91, -91, -91, -91, -91, -91, -91, -91, -91,
                    -91, -91, -91, -91, -91, -91, -91, -91, -91, -91,
                    -91, -91, -91, -91, -91, -91, -91, -91, -91, -91,
                    -91, -91, -91, -91, -91, -91, -91, -91, -91, -91,
                    -91, -91, -91, -91, -91, -91

                },

                {
                    17, 92, 92, -92, 92, -92, 92, -92, 92, 92,
                    92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 93, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92
                },

                {
                    17, 92, 92, -93, 92, -93, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 93, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92, 92, 92, 92, 92,
                    92, 92, 92, 92, 92, 92

                },

                {
                    17, 94, 94, -94, 94, -94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94
                },

                {
                    17, 94, 95, -95, 94, -95, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 96, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94

                },

                {
                    17, 94, 94, 115, 94, 115, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
                    94, 94, 94, 94, 94, 94
                },

                {
                    17, 97, 97, -97, 97, -97, 97, 97, 97, 97,
                    97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
                    97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
                    97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
                    97, 97, 97, 97, 97, 97

                },

                {
                    17, 98, 98, 99, 98, -98, 98, 98, 98, 98,
                    98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
                    98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
                    98, 98, 98, 98, 98, 98, 98, 98, 98, 98,
                    98, 98, 98, 98, 98, -98
                },

                {
                    17, 116, 116, 99, 116, -99, 116, 116, 116, 116,
                    116, 116, 116, 116, 116, 116, 116, 116, 116, 116,
                    116, 116, 116, 116, 116, 116, 116, 116, 116, 116,
                    116, 116, 116, 116, 116, 116, 116, 116, 116, 116,
                    116, 116, 116, 116, 116, -99

                },

                {
                    17, -100, -100, -100, -100, -100, -100, -100, -100, -100,
                    -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
                    -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
                    -100, -100, -100, -100, -100, -100, -100, -100, -100, -100,
                    -100, -100, -100, -100, -100, -100
                },

                {
                    17, -101, -101, -101, -101, -101, -101, -101, -101, -101,
                    -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
                    -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
                    -101, -101, -101, -101, -101, -101, -101, -101, -101, -101,
                    -101, -101, -101, -101, -101, -101

                },

                {
                    17, 102, 102, 102, 102, 102, 102, 102, 102, 102,
                    -102, -102, 102, 102, 102, 102, 102, 102, 102, 102,
                    102, -102, 102, 102, 102, 102, 102, 102, 102, 102,
                    102, 102, 102, 102, 102, 102, 102, 102, 102, 102,
                    102, 102, 102, 102, 102, 102
                },

                {
                    17, -103, -103, -103, -103, -103, -103, -103, -103, -103,
                    -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
                    -103, -103, -103, -103, -103, -103, -103, -103, -103, -103,
                    -103, -103, 117, -103, -103, -103, -103, -103, -103, -103,
                    -103, -103, -103, -103, -103, -103

                },

                {
                    17, -104, 118, 118, 118, 118, 70, -104, -104, -104,
                    -104, -104, -104, 70, -104, -104, 70, 70, 70, 70,
                    -104, -104, -104, -104, -104, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, 70, 70, 70, 70, 70, 70,
                    70, 70, 70, 70, -104, -104
                },

                {
                    17, -105, 119, 119, 119, 119, -105, -105, -105, -105,
                    -105, -105, -105, -105, -105, -105, -105, -105, -105, -105,
                    -105, -105, -105, -105, -105, -105, -105, -105, -105, -105,
                    -105, -105, -105, -105, -105, -105, -105, -105, -105, -105,
                    -105, -105, -105, -105, -105, -105

                },

                {
                    17, -106, -106, -106, -106, -106, -106, -106, -106, -106,
                    -106, -106, -106, 120, -106, -106, -106, -106, -106, -106,
                    -106, -106, -106, -106, -106, -106, -106, -106, -106, -106,
                    -106, -106, -106, -106, -106, -106, -106, -106, -106, -106,
                    -106, -106, -106, -106, -106, -106
                },

                {
                    17, -107, -107, -107, -107, -107, -107, -107, -107, -107,
                    -107, -107, -107, -107, -107, -107, 81, 81, 81, 81,
                    -107, -107, -107, -107, 81, 81, 81, 121, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -107, -107

                },

                {
                    17, -108, -108, -108, -108, -108, -108, -108, -108, -108,
                    -108, -108, -108, -108, -108, -108, 81, 81, 81, 81,
                    -108, -108, -108, -108, 81, 81, 81, 81, 81, 122,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -108, -108
                },

                {
                    17, -109, -109, -109, -109, -109, -109, -109, -109, -109,
                    -109, -109, -109, -109, -109, -109, 81, 81, 81, 81,
                    -109, -109, -109, -109, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 123, 81, 81, 81,
                    81, 81, 81, 81, -109, -109

                },

                {
                    17, -110, -110, -110, -110, -110, -110, -110, -110, -110,
                    -110, -110, -110, -110, -110, -110, 81, 81, 81, 81,
                    -110, -110, -110, -110, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -110, -110
                },

                {
                    17, -111, -111, -111, -111, -111, -111, -111, -111, -111,
                    -111, -111, -111, -111, -111, -111, 81, 81, 81, 81,
                    -111, -111, -111, -111, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 124, 81, 81, -111, -111

                },

                {
                    17, -112, -112, -112, -112, -112, -112, -112, -112, -112,
                    -112, -112, -112, -112, -112, -112, 81, 81, 81, 81,
                    -112, -112, -112, -112, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 125, 81, 81, 81,
                    81, 81, 81, 81, -112, -112
                },

                {
                    17, -113, -113, -113, -113, -113, -113, -113, -113, -113,
                    -113, -113, -113, -113, -113, -113, 81, 81, 81, 81,
                    -113, -113, -113, -113, 81, 81, 81, 81, 81, 126,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -113, -113

                },

                {
                    17, -114, -114, -114, -114, -114, -114, -114, -114, -114,
                    -114, -114, -114, -114, -114, -114, 81, 81, 81, 81,
                    -114, -114, -114, -114, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    127, 81, 81, 81, -114, -114
                },

                {
                    17, -115, -115, 115, -115, 115, -115, -115, -115, -115,
                    -115, -115, -115, -115, -115, -115, -115, -115, -115, -115,
                    -115, -115, -115, -115, -115, -115, -115, -115, -115, -115,
                    -115, -115, -115, -115, -115, -115, -115, -115, -115, -115,
                    -115, -115, -115, -115, -115, -115

                },

                {
                    17, 116, 116, 99, 116, -116, 116, 116, 116, 116,
                    116, 116, 116, 116, 116, 116, 116, 116, 116, 116,
                    116, 116, 116, 116, 116, 116, 116, 116, 116, 116,
                    116, 116, 116, 116, 116, 116, 116, 116, 116, 116,
                    116, 116, 116, 116, 116, -116
                },

                {
                    17, -117, -117, -117, -117, -117, -117, -117, -117, -117,
                    -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
                    -117, -117, -117, -117, -117, -117, -117, -117, -117, -117,
                    -117, -117, -117, 128, -117, -117, -117, -117, -117, -117,
                    -117, -117, -117, -117, -117, -117

                },

                {
                    17, -118, 118, 118, 118, 118, -118, -118, -118, -118,
                    -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
                    -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
                    -118, -118, -118, -118, -118, -118, -118, -118, -118, -118,
                    -118, -118, -118, -118, -118, -118
                },

                {
                    17, -119, 119, 119, 119, 119, -119, -119, -119, -119,
                    -119, -119, -119, -119, -119, -119, -119, -119, -119, -119,
                    -119, -119, -119, -119, -119, -119, -119, -119, -119, -119,
                    -119, -119, -119, -119, -119, -119, -119, -119, -119, -119,
                    -119, -119, -119, -119, -119, -119

                },

                {
                    17, -120, -120, -120, -120, -120, -120, -120, -120, -120,
                    -120, -120, -120, -120, -120, -120, -120, 129, -120, -120,
                    -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
                    -120, -120, -120, -120, -120, -120, -120, -120, -120, -120,
                    -120, -120, -120, -120, -120, -120
                },

                {
                    17, -121, -121, -121, -121, -121, -121, -121, -121, -121,
                    -121, -121, -121, -121, -121, -121, 81, 81, 81, 81,
                    -121, -121, -121, -121, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 130, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -121, -121

                },

                {
                    17, -122, -122, -122, -122, -122, -122, -122, -122, -122,
                    -122, -122, -122, -122, -122, -122, 81, 81, 81, 81,
                    -122, -122, -122, -122, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -122, -122
                },

                {
                    17, -123, -123, -123, -123, -123, -123, -123, -123, -123,
                    -123, -123, -123, -123, -123, -123, 81, 81, 81, 81,
                    -123, -123, -123, -123, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    131, 81, 81, 81, -123, -123

                },

                {
                    17, -124, -124, -124, -124, -124, -124, -124, -124, -124,
                    -124, -124, -124, -124, -124, -124, 81, 81, 81, 81,
                    -124, -124, -124, -124, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 132, 81, 81, 81, 81,
                    81, 81, 81, 81, -124, -124
                },

                {
                    17, -125, -125, -125, -125, -125, -125, -125, -125, -125,
                    -125, -125, -125, -125, -125, -125, 81, 81, 81, 81,
                    -125, -125, -125, -125, 81, 81, 81, 81, 133, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -125, -125

                },

                {
                    17, -126, -126, -126, -126, -126, -126, -126, -126, -126,
                    -126, -126, -126, -126, -126, -126, 81, 81, 81, 81,
                    -126, -126, -126, -126, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -126, -126
                },

                {
                    17, -127, -127, -127, -127, -127, -127, -127, -127, -127,
                    -127, -127, -127, -127, -127, -127, 81, 81, 81, 81,
                    -127, -127, -127, -127, 81, 81, 81, 81, 81, 134,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -127, -127

                },

                {
                    17, -128, -128, -128, -128, -128, -128, -128, -128, -128,
                    -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
                    -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
                    -128, -128, -128, -128, -128, -128, -128, -128, -128, -128,
                    135, -128, -128, -128, -128, -128
                },

                {
                    17, -129, -129, -129, -129, -129, -129, -129, -129, -129,
                    -129, -129, -129, -129, -129, 136, -129, -129, -129, -129,
                    -129, -129, -129, -129, -129, -129, -129, -129, -129, -129,
                    -129, -129, -129, -129, -129, -129, -129, -129, -129, -129,
                    -129, -129, -129, -129, -129, -129

                },

                {
                    17, -130, -130, -130, -130, -130, -130, -130, -130, -130,
                    -130, -130, -130, -130, -130, -130, 81, 81, 81, 81,
                    -130, -130, -130, -130, 81, 81, 81, 81, 81, 137,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    138, 81, 81, 81, -130, -130
                },

                {
                    17, -131, -131, -131, -131, -131, -131, -131, -131, -131,
                    -131, -131, -131, -131, -131, -131, 81, 81, 81, 81,
                    -131, -131, -131, -131, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -131, -131

                },

                {
                    17, -132, -132, -132, -132, -132, -132, -132, -132, -132,
                    -132, -132, -132, -132, -132, -132, 81, 81, 81, 81,
                    -132, -132, -132, -132, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    139, 81, 81, 81, -132, -132
                },

                {
                    17, -133, -133, -133, -133, -133, -133, -133, -133, -133,
                    -133, -133, -133, -133, -133, -133, 81, 81, 81, 81,
                    -133, -133, -133, -133, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -133, -133

                },

                {
                    17, -134, -134, -134, -134, -134, -134, -134, -134, -134,
                    -134, -134, -134, -134, -134, -134, 81, 81, 81, 81,
                    -134, -134, -134, -134, 81, 81, 81, 81, 81, 140,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    141, 81, 81, 81, -134, -134
                },

                {
                    17, -135, -135, -135, -135, -135, -135, -135, -135, -135,
                    -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
                    -135, -135, -135, -135, -135, -135, -135, -135, -135, 142,
                    -135, -135, -135, -135, -135, -135, -135, -135, -135, -135,
                    -135, -135, -135, -135, -135, -135

                },

                {
                    17, -136, -136, -136, -136, -136, -136, -136, -136, -136,
                    -136, -136, -136, -136, -136, -136, -136, -136, 143, -136,
                    -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
                    -136, -136, -136, -136, -136, -136, -136, -136, -136, -136,
                    -136, -136, -136, -136, -136, -136
                },

                {
                    17, -137, -137, -137, -137, -137, -137, -137, -137, -137,
                    -137, -137, -137, -137, -137, -137, 81, 81, 81, 81,
                    -137, -137, -137, -137, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 144, 81, 81, 81, 81,
                    81, 81, 81, 81, -137, -137

                },

                {
                    17, -138, -138, -138, -138, -138, -138, -138, -138, -138,
                    -138, -138, -138, -138, -138, -138, 81, 81, 81, 81,
                    -138, -138, -138, -138, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 145, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -138, -138
                },

                {
                    17, -139, -139, -139, -139, -139, -139, -139, -139, -139,
                    -139, -139, -139, -139, -139, -139, 81, 81, 81, 81,
                    -139, -139, -139, -139, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -139, -139

                },

                {
                    17, -140, -140, -140, -140, -140, -140, -140, -140, -140,
                    -140, -140, -140, -140, -140, -140, 81, 81, 81, 81,
                    -140, -140, -140, -140, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 146, 81, 81, 81, 81,
                    81, 81, 81, 81, -140, -140
                },

                {
                    17, -141, -141, -141, -141, -141, -141, -141, -141, -141,
                    -141, -141, -141, -141, -141, -141, 81, 81, 81, 81,
                    -141, -141, -141, -141, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 147, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -141, -141

                },

                {
                    17, -142, -142, -142, -142, -142, -142, -142, -142, -142,
                    -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
                    -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
                    -142, -142, -142, -142, -142, -142, -142, -142, -142, -142,
                    -142, -142, -142, -142, -142, -142
                },

                {
                    17, -143, 148, 148, 148, 148, -143, -143, -143, -143,
                    -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
                    -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
                    -143, -143, -143, -143, -143, -143, -143, -143, -143, -143,
                    -143, -143, -143, -143, -143, -143

                },

                {
                    17, -144, -144, -144, -144, -144, -144, -144, -144, -144,
                    -144, -144, -144, -144, -144, -144, 81, 81, 81, 81,
                    -144, -144, -144, -144, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 149, 81, 81,
                    81, 81, 81, 81, -144, -144
                },

                {
                    17, -145, -145, -145, -145, -145, -145, -145, -145, -145,
                    -145, -145, -145, -145, -145, -145, 81, 81, 81, 81,
                    -145, -145, -145, -145, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    150, 81, 81, 81, -145, -145

                },

                {
                    17, -146, -146, -146, -146, -146, -146, -146, -146, -146,
                    -146, -146, -146, -146, -146, -146, 81, 81, 81, 81,
                    -146, -146, -146, -146, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 151, 81, 81,
                    81, 81, 81, 81, -146, -146
                },

                {
                    17, -147, -147, -147, -147, -147, -147, -147, -147, -147,
                    -147, -147, -147, -147, -147, -147, 81, 81, 81, 81,
                    -147, -147, -147, -147, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    152, 81, 81, 81, -147, -147

                },

                {
                    17, -148, 148, 148, 148, 148, -148, -148, -148, -148,
                    -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
                    -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
                    -148, -148, -148, -148, -148, -148, -148, -148, -148, -148,
                    -148, -148, -148, -148, -148, -148
                },

                {
                    17, -149, -149, -149, -149, -149, -149, -149, -149, -149,
                    -149, -149, -149, -149, -149, -149, 81, 81, 81, 81,
                    -149, -149, -149, -149, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -149, -149

                },

                {
                    17, -150, -150, -150, -150, -150, -150, -150, -150, -150,
                    -150, -150, -150, -150, -150, -150, 81, 81, 81, 81,
                    -150, -150, -150, -150, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 153, 81, 81, 81, 81,
                    81, 81, 81, 81, -150, -150
                },

                {
                    17, -151, -151, -151, -151, -151, -151, -151, -151, -151,
                    -151, -151, -151, -151, -151, -151, 81, 81, 81, 81,
                    -151, -151, -151, -151, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -151, -151

                },

                {
                    17, -152, -152, -152, -152, -152, -152, -152, -152, -152,
                    -152, -152, -152, -152, -152, -152, 81, 81, 81, 81,
                    -152, -152, -152, -152, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 154, 81, 81, 81, 81,
                    81, 81, 81, 81, -152, -152
                },

                {
                    17, -153, -153, -153, -153, -153, -153, -153, -153, -153,
                    -153, -153, -153, -153, -153, -153, 81, 81, 81, 81,
                    -153, -153, -153, -153, 81, 81, 81, 81, 81, 155,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -153, -153

                },

                {
                    17, -154, -154, -154, -154, -154, -154, -154, -154, -154,
                    -154, -154, -154, -154, -154, -154, 81, 81, 81, 81,
                    -154, -154, -154, -154, 81, 81, 81, 81, 81, 156,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -154, -154
                },

                {
                    17, -155, -155, -155, -155, -155, -155, -155, -155, -155,
                    -155, -155, -155, -155, -155, -155, 81, 81, 81, 81,
                    -155, -155, -155, -155, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -155, -155

                },

                {
                    17, -156, -156, -156, -156, -156, -156, -156, -156, -156,
                    -156, -156, -156, -156, -156, -156, 81, 81, 81, 81,
                    -156, -156, -156, -156, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
                    81, 81, 81, 81, -156, -156
                },

            };


/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
    static void YY_DO_BEFORE_ACTION(int bp, int cp) {
        yytext_ptr = bp;
        yyleng = (cp - bp);
//        yy_hold_char = yytext[cp];
//        yytext[cp] = '\0';
        yy_c_buf_p = cp;
    }

    static final int YY_NUM_RULES = 51;
    static final int YY_END_OF_BUFFER = 52;
    static final int[] yy_accept = // short[157]
            {0,
             0, 0, 4, 4, 0, 0, 0, 0, 23, 23,
             27, 27, 0, 0, 0, 0, 52, 50, 1, 1,
             36, 2, 44, 37, 50, 43, 41, 41, 28, 3,
             43, 29, 4, 51, 20, 20, 19, 19, 17, 18,
             17, 17, 17, 17, 17, 17, 17, 22, 21, 23,
             26, 26, 25, 23, 27, 30, 35, 34, 31, 47,
             45, 46, 49, 49, 1, 36, 2, 37, 42, 43,
             43, 0, 41, 0, 41, 28, 3, 4, 0, 18,
             17, 17, 17, 17, 17, 17, 17, 17, 17, 21,
             21, 23, 23, 25, 25, 24, 27, 30, 30, 32,

             33, 47, 0, 39, 40, 0, 17, 17, 17, 10,
             17, 17, 17, 17, 24, 30, 0, 39, 40, 0,
             17, 13, 17, 17, 17, 12, 17, 0, 0, 6,
             11, 17, 14, 5, 0, 0, 17, 17, 7, 17,
             17, 48, 38, 17, 17, 17, 17, 38, 16, 17,
             15, 17, 17, 17, 9, 8
            };

    static final int[] yy_ec = // int[256]
            {0,
             1, 1, 1, 1, 1, 1, 1, 1, 2, 3,
             1, 4, 5, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 2, 6, 7, 6, 8, 9, 1, 1, 10,
             11, 12, 6, 6, 13, 14, 15, 16, 17, 18,
             19, 19, 19, 19, 19, 19, 19, 1, 20, 1,
             6, 1, 6, 1, 25, 26, 27, 28, 29, 30,
             31, 32, 33, 31, 34, 35, 31, 36, 37, 31,
             31, 38, 39, 40, 41, 42, 43, 31, 31, 31,
             21, 22, 23, 1, 24, 1, 25, 26, 27, 28,

             29, 30, 31, 32, 33, 31, 34, 35, 31, 36,
             37, 31, 31, 38, 39, 40, 41, 42, 43, 31,
             31, 31, 44, 1, 45, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,

             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1
            };

    static /*yy_state_type*/ int yy_last_accepting_state;
    static int yy_last_accepting_cpos;  // char *


    static final int YY_MORE_ADJ = 0;

    static void YY_RESTORE_YY_MORE_OFFSET() {}

    ///#line 1 "lexpgn.l"
    static final int INITIAL = 0;
    ///#line 2 "lexpgn.l"

/* lexpgn by David A. Wheeler (http://www.dwheeler.com).

   This code processes files formatted using PGN, as defined in
   "Standard Portable Game Notation Specification and Implementation
   Guide" Revised 1994.03.12 by Steven J. Edwards.

   This code lexically analyzes PGN files as an import format; since it's
   importing, it tries to accept nonstandard formats as much as it can and
   figure out the "intent".  It handles varying newlines (e.g. \r), etc.
   It will accept a great deal of misformatting that isn't,
   strictly speaking, legal PGN, but the point is to be able to figure
   out what was intended.

   Calling the lexer will process ONE game in a file,
   starting with 0 or more tags, followed by 0 or more moves.
   It returns 0 if no erors, 1 if errors, 2 if terminated (normally).

   It will place data somewhere depending on the value of data_dest;
   if data_dest is DEST_TRASH, it skips the game (not fully implemented),
   if data_dest is DEST_GAME, it stores into Game[],
   if data_dest is DEST_BOOK, it's stored into the book material.
   To process a multi-game PGN file, call it again and again.

   Some of the funny ordering (e.g., for bracecomment) is to make it
   high speed.  Flex/lex can produce high speed lexers, but only
   if it gets some help, in particular by defining patterns that
   maximally match.

   TODO: prevent buffer overflow for FEN.


*/

    /*
    enum tagtype { NO_TAG, EVENT_TAG, SITE_TAG, DATE_TAG, ROUND_TAG,
               WHITE_TAG, BLACK_TAG, RESULT_TAG,
                   WHITE_ELO_TAG, BLACK_ELO_TAG,
                   WHITETITLE_TAG, BLACKTITLE_TAG, FEN_TAG,
                   OTHER_TAG };
    */
    static final int NO_TAG = 0;
    static final int EVENT_TAG = 1;
    static final int SITE_TAG = 2;
    static final int DATE_TAG = 3;
    static final int ROUND_TAG = 4;
    static final int
            WHITE_TAG = 5;
    static final int BLACK_TAG = 6;
    static final int RESULT_TAG = 7;
    static final int
            WHITE_ELO_TAG = 8;
    static final int BLACK_ELO_TAG = 9;
    static final int
            WHITETITLE_TAG = 10;
    static final int BLACKTITLE_TAG = 11;
    static final int FEN_TAG = 12;
    static final int
            OTHER_TAG = 13;

    //enum data_destination_t { DEST_TRASH, DEST_GAME, DEST_BOOK };

    static final int DEST_TRASH = 0;
    static final int DEST_GAME = 1;
    static final int DEST_BOOK = 2;
    static /*data_destination_t*/int data_dest;


    public static String pgn_event;
    public static String pgn_site;
    public static String pgn_date;
    public static String pgn_round;
    public static String pgn_white;
    public static String pgn_black;
    public static String pgn_result;
    public static String pgn_whiteELO;
    public static String pgn_blackELO;
    public static String pgn_othertags;
    public static String initial_comments; /* PGN comments before any moves */

    static String return_append_str(String dest, String s) {
/* Append text s to dest, and return new result. */
        return dest + s;
    }

//    void append_str(char **dest, String s) {
///* Append text s to *dest, and modify *dest to new location. */
//        char *temp;
//        temp = return_append_str(*dest, s);
//        *dest = temp;
//    }

    static void append_comment(String t) {
/* Append PGN text t after the current move */
        if (data_dest == DEST_GAME) {
            /* TODO */
            if (GameCnt < 1) {
                initial_comments = return_append_str(initial_comments, t);
            } else {
                Game[GameCnt].comments = return_append_str(Game[GameCnt].comments, t);
            }
        }
    }

    static final int tag_gobble = 1;

    static final int tagsymbol = 2;

    static final int tagsep = 3;

    static final int tagdata = 4;

    static final int tagend = 5;

    static final int bracecomment = 6;

    static final int RAV = 7;

    ///#line 1816 "lexpgn.c"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */


/* Amount of stuff to slurp up with each read. */

    static final int YY_READ_BUF_SIZE = 8192;


/* Copy whatever the last rule matched to the standard output. */

    static void ECHO() {
        try {
            yyout.write(yytext());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
    ///#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )


/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
    static int YY_INPUT(int offset, int max_size) {
        try {
            int n = yyin.read(yy_current_buffer.yy_ch_buf, offset, max_size);
            if (n < 0)
                n = 0;
            return n;
        } catch (IOException e) {
            e.printStackTrace();
            // "input in flex scanner failed"
            System.exit(1);
            return 0;
        }
        // if ( (result = read( fileno(yyin), (char *) buf, max_size )) < 0 )
        //     YY_FATAL_ERROR( "input in flex scanner failed" );
    }


/* Number of entries by which start-condition stack grows. */
    static final int YY_START_STACK_INCR = 25;

/* Report a fatal error. */
    static void YY_FATAL_ERROR(String msg) {yy_fatal_error(msg);}


    static void YY_RULE_SETUP() {
        if (yyleng > 0)
            yy_current_buffer.yy_at_bol =
                    (yytext().endsWith("\n"));
    }


    static int yylex() {
        /*yy_state_type*/ int yy_current_state;
        int yy_cp, yy_bp;
        int yy_act;

        // #line 129 "lexpgn.l"

        /* These are executed on each entry to the code */
        boolean seen_tags = false;
        boolean seen_moves = false;
        /*tagtype*/ int ctag = NO_TAG;
        int firstmovenum = -1;
        int side = white;
        int rav_count = 0;
        int result = Book.R_NORESULT;
        String tagname = ""; /* Name of tag currently being processed */
        int p; // leaf*
        boolean[] addtobook = new boolean[]{false, false};

        // #line 1974 "lexpgn.c"

        if (yy_init) {
            yy_init = false;

            if (yy_start == 0)
                yy_start = 1;	/* first start state */

            if (yyin == null) {
                yyin = new BufferedReader(new InputStreamReader(System.in));
                yy_set_interactive(true);
            }

            if (yyout == null)
                yyout = new BufferedWriter(new OutputStreamWriter(System.out));

            if (yy_current_buffer == null)
                yy_current_buffer =
                        yy_create_buffer(yyin, YY_BUF_SIZE);

            yy_load_buffer_state();
        }

        while (true)		/* loops until end-of-file is reached */ {
            yy_cp = yy_c_buf_p;

            /* Support of yytext. */
//            yytext[yy_cp] = yy_hold_char;

            /* yy_bp points to the position in yy_ch_buf of the start of
             * the current run.
             */
            yy_bp = yy_cp;

            yy_current_state = yy_start;
            yy_current_state += YY_AT_BOL() ? 1 : 0;

            // this loop exists to accommodate the gotos from the C version by using labeled continue statements
            yy_match:
            while (true) {

                while ((yy_current_state = yy_nxt[yy_current_state][yy_ec[YY_SC_TO_UI(bufchar(yy_cp))]]) > 0) {
                    if (yy_accept[yy_current_state] != 0) {
                        yy_last_accepting_state = yy_current_state;
                        yy_last_accepting_cpos = yy_cp;
                    }

                    ++yy_cp;
                }

                yy_current_state = -yy_current_state;

                yy_find_action:
                // this loop exists to accommodate the gotos from the C version by using labeled continue statements
                while (true) {
                    yy_act = yy_accept[yy_current_state];

                    YY_DO_BEFORE_ACTION(yy_bp, yy_cp);


                    do_action:	/* This label is used only to access EOF actions. */
                    // this loop exists to accommodate the gotos from the C version by using labeled continue statements
                    while (true) {


                        switch (yy_act) { /* beginning of action switch */
                            case 0: /* must back up */
                                /* undo the effects of YY_DO_BEFORE_ACTION */
//                yytext[yy_cp] = yy_hold_char;
                                yy_cp = yy_last_accepting_cpos + 1;
                                yy_current_state = yy_last_accepting_state;
                                continue yy_find_action;

                            case 1:
                                YY_RULE_SETUP();
                                // #line 145 "lexpgn.l"
                                { /* Ignore whitespace */ }
                                break;
                            case 2:
                                YY_RULE_SETUP();
                                // #line 146 "lexpgn.l"
                                { /* Ignore PGN escape. We'll allow initial space. */ }
                                break;
                            case 3:
                                YY_RULE_SETUP();
                                // #line 148 "lexpgn.l"
                                {
                                    /* Handle "[".  If we've already seen a move, return "[" to
                                       the stream and return. */
                                    /* We rashly match on any SC to avoid trouble with unmatched
                                       brackets of various types */
                                    seen_tags = true;
                                    ctag = NO_TAG;
                                    if (seen_moves) {
                                        BEGIN(INITIAL);
                                        yyless(yy_bp, yy_cp, 0); /* put the "[" back. */
                                        return 0;
                                    }
                                    if (data_dest == DEST_TRASH) {BEGIN(tag_gobble);} else { BEGIN(tagsymbol); }
                                }
                                break;
                            case 4:
                                YY_RULE_SETUP();
                                // #line 165 "lexpgn.l"
                                {BEGIN(INITIAL);}
                                break;
                            case 5:
                                YY_RULE_SETUP();
                                // #line 167 "lexpgn.l"
                                {
                                    ctag = WHITE_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 6:
                                YY_RULE_SETUP();
                                // #line 168 "lexpgn.l"
                                {
                                    ctag = BLACK_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 7:
                                YY_RULE_SETUP();
                                // #line 169 "lexpgn.l"
                                {
                                    ctag = RESULT_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 8:
                                YY_RULE_SETUP();
                                // #line 170 "lexpgn.l"
                                {
                                    ctag = WHITETITLE_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 9:
                                YY_RULE_SETUP();
                                // #line 171 "lexpgn.l"
                                {
                                    ctag = BLACKTITLE_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 10:
                                YY_RULE_SETUP();
                                // #line 172 "lexpgn.l"
                                {
                                    ctag = FEN_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 11:
                                YY_RULE_SETUP();
                                // #line 173 "lexpgn.l"
                                {
                                    ctag = EVENT_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 12:
                                YY_RULE_SETUP();
                                // #line 174 "lexpgn.l"
                                {
                                    ctag = SITE_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 13:
                                YY_RULE_SETUP();
                                // #line 175 "lexpgn.l"
                                {
                                    ctag = DATE_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 14:
                                YY_RULE_SETUP();
                                // #line 176 "lexpgn.l"
                                {
                                    ctag = ROUND_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 15:
                                YY_RULE_SETUP();
                                // #line 177 "lexpgn.l"
                                {
                                    ctag = WHITE_ELO_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 16:
                                YY_RULE_SETUP();
                                // #line 178 "lexpgn.l"
                                {
                                    ctag = BLACK_ELO_TAG;
                                    BEGIN(tagsep);
                                }
                                break;
                            case 17:
                                YY_RULE_SETUP();
                                // #line 179 "lexpgn.l"
                                {
                                    ctag = OTHER_TAG;
                                    tagname = yytext();
                                    BEGIN(tagsep);
                                }
                                break;
                            case 18:
                                YY_RULE_SETUP();
                                // #line 188 "lexpgn.l"
                                {BEGIN(INITIAL); /* No tag name, skip. */}
                                break;
                            case 19:
                                YY_RULE_SETUP();
                                // #line 189 "lexpgn.l"
                                {BEGIN(INITIAL); /* Line ended early. */}
                                break;
                            case 20:
                                YY_RULE_SETUP();
                                // #line 190 "lexpgn.l"
                                {
                                    System.out.println("Bad character as tag name: " + yytext());
                                    return 1;
                                }
                                //break;
                            case 21:
                                YY_RULE_SETUP();
                                // #line 195 "lexpgn.l"
                                {BEGIN(tagdata);}
                                break;
                            case 22:
                                YY_RULE_SETUP();
                                // #line 196 "lexpgn.l"
                                {
                                    System.out.println("Bad character as tag separator: " + yytext());
                                    return 1;
                                }
                                //break;
                            case 23:
                                YY_RULE_SETUP();
                                // #line 201 "lexpgn.l"
                                { /* tag data */

                                    /* We start at first " in tag, and must match
                                       till we reach an unprotected " or end of line */

                                    BEGIN(tagend);
                                    /* TODO: if DEST_GAME, store tag symbol and data for later saving */
                                    switch (ctag) {
                                        case WHITE_TAG:
                                            /* printf("White = %s\n", yytext); */
                                            if ((data_dest == DEST_BOOK) &&
                                                    PGN.IsTrustedPlayer(yytext()))
                                                addtobook[white] = true;
                                            if (data_dest == DEST_GAME)
                                                pgn_white = yytext();
                                            break;
                                        case BLACK_TAG:
                                            /* printf("Black = %s\n", yytext); */
                                            if ((data_dest == DEST_BOOK) &&
                                                    PGN.IsTrustedPlayer(yytext()))
                                                addtobook[black] = true;
                                            if (data_dest == DEST_GAME)
                                                pgn_black = yytext();
                                            break;
                                        case RESULT_TAG:
                                            /* printf("Result = %s\n", yytext); */
                                            if (yytext().equals("1-0"))
                                                result = Book.R_WHITE_WINS;
                                            else if (yytext().equals("0-1"))
                                                result = Book.R_BLACK_WINS;
                                            else if (yytext().equals("1/2-1/2"))
                                                result = Book.R_DRAW;
                                            if (data_dest == DEST_GAME)
                                                pgn_result = yytext();
                                            break;
                                        case WHITETITLE_TAG: /* We'll trust GM, IM, FMs */
                                            if (data_dest == DEST_BOOK &&
                                                    (yytext().equals("GM") ||
                                                    yytext().equals("IM") ||
                                                    yytext().equals("FM")))
                                                addtobook[white] = true;
                                            if (data_dest == DEST_GAME) {
                                                pgn_othertags += "[WhiteTitle \"";
                                                pgn_othertags += yytext();
                                                pgn_othertags += "\"]\n";
                                            }
                                            break;
                                        case BLACKTITLE_TAG:
                                            if (data_dest == DEST_BOOK &&
                                                    (yytext().equals("GM") ||
                                                    yytext().equals("IM") ||
                                                    yytext().equals("FM")))
                                                addtobook[black] = true;
                                            if (data_dest == DEST_GAME) {
                                                pgn_othertags += "[BlackTitle \"";
                                                pgn_othertags += yytext();
                                                pgn_othertags += "\"]\n";
                                            }
                                            break;
                                        case FEN_TAG:
                                            /* Legal FEN is no more than 81 chars long, because
                                               71 (a character for every board cell, plus
                                               separators) + 1 (space) + 1 (side, w or b) +
                                               1 (space) + 4 (castling, KQkq) + 1 (space) +
                                               2 (en passant) = 71.  We'll leave one char
                                               for miscount/whitespace. This doesn't fully
                                               protect against buffer overflow attacks; the
                                               parsing routine still has to check to make sure
                                               its input don't force it to walk off the end
                                               of any arrays. Still, it helps as a sanity check. */
                                            /* printf("FEN tag encountered \"%s\"\n",yytext); */
                                            if (yyleng > 82) {
                                                System.out.println("Error: FEN too long: " + yytext());
                                                return 1;
                                            }
                                            /* Doesn't return failure/success; just
                                               do the best you can */
                                            EPD.ParseEPD(yytext());
                                            /* Remember it can be black to move now */
                                            side = board.side;
                                            if (data_dest == DEST_GAME) {
                                                pgn_othertags += "[FEN \"";
                                                pgn_othertags += yytext();
                                                pgn_othertags += "\"]\n";
                                            }
                                            break;
                                        case EVENT_TAG:
                                            if (data_dest == DEST_GAME)
                                                pgn_event = yytext();
                                            break;
                                        case SITE_TAG:
                                            if (data_dest == DEST_GAME)
                                                pgn_site = yytext();
                                            break;
                                        case DATE_TAG:
                                            if (data_dest == DEST_GAME)
                                                pgn_date = yytext();
                                            break;
                                        case ROUND_TAG:
                                            if (data_dest == DEST_GAME)
                                                pgn_round = yytext();
                                            break;
                                        case WHITE_ELO_TAG:
                                            if (data_dest == DEST_GAME)
                                                pgn_whiteELO = yytext();
                                            break;
                                        case BLACK_ELO_TAG:
                                            if (data_dest == DEST_GAME)
                                                pgn_blackELO = yytext();
                                            break;
                                        case OTHER_TAG:
                                            if (data_dest == DEST_GAME) {
                                                pgn_othertags += "[";
                                                pgn_othertags += tagname;   // fixc tagname may not have been inited
                                                pgn_othertags += " \"";
                                                pgn_othertags += yytext();
                                                pgn_othertags += "\"]\n";
                                            }
                                            break;
                                    }
                                }
                                break;
                            case 24:
                                YY_RULE_SETUP();
                                // #line 319 "lexpgn.l"
                                {BEGIN(INITIAL);}
                                break;
                            case 25:
                                YY_RULE_SETUP();
                                // #line 320 "lexpgn.l"
                                {BEGIN(INITIAL); /* Garbage, do what can. */}
                                break;
                            case 26:
                                YY_RULE_SETUP();
                                // #line 321 "lexpgn.l"
                                {BEGIN(INITIAL); /* End-of-line. */}
                                break;
                            case 27:
                                YY_RULE_SETUP();
                                // #line 323 "lexpgn.l"
                                {BEGIN(INITIAL); /* Consume leftover */}
                                break;
                            case 28:
                                YY_RULE_SETUP();
                                // #line 325 "lexpgn.l"
                                { /* PGN comment */
                                    seen_moves = true;
                                    append_comment(yytext());
                                    append_comment("\n");
                                }
                                break;
                            case 29:
                                YY_RULE_SETUP();
                                // #line 331 "lexpgn.l"
                                { /* PGN comment */
                                    seen_moves = true;
                                    append_comment(yytext());
                                    BEGIN(bracecomment);
                                }
                                break;
                            case 30:
                                YY_RULE_SETUP();
                                // #line 336 "lexpgn.l"
                                { /* PGN comment; may embed \n */
                                    append_comment(yytext());
                                }
                                break;
                            case 31:
                                YY_RULE_SETUP();
                                // #line 339 "lexpgn.l"
                                {
                                    append_comment(yytext());
                                    BEGIN(INITIAL);
                                }
                                break;
                            case 32:
                                YY_RULE_SETUP();
                                // #line 343 "lexpgn.l"
                                { append_comment("\n"); }
                                break;
                            case 33:
                                YY_RULE_SETUP();
                                // #line 344 "lexpgn.l"
                                { append_comment("\n"); }
                                break;
                            case 34:
                                YY_RULE_SETUP();
                                // #line 345 "lexpgn.l"
                                { append_comment("\n"); }
                                break;
                            case 35:
                                YY_RULE_SETUP();
                                // #line 346 "lexpgn.l"
                                { append_comment("\n"); }
                                break;
                            case 36:
                                YY_RULE_SETUP();
                                // #line 349 "lexpgn.l"
                                {
                                    seen_moves = true; /* Numeric Annotation Glyph */
                                    append_comment(yytext());
                                }
                                break;
                            case 37:
                                YY_RULE_SETUP();
                                // #line 353 "lexpgn.l"
                                { return 0; /* could check if consistent w/Result */ }
                                //break;
                            case 38:
                                YY_RULE_SETUP();
                                // #line 354 "lexpgn.l"
                                { return 0; }
//                                break;
                            case 39:
                                YY_RULE_SETUP();
                                // #line 355 "lexpgn.l"
                                { return 0; }
//                                break;
                            case 40:
                                YY_RULE_SETUP();
                                // #line 356 "lexpgn.l"
                                { return 0; }
//                                break;
                            case 41:
                                YY_RULE_SETUP();
                                // #line 358 "lexpgn.l"
                                {
                                    seen_moves = true; /* Move number */
                                    if (firstmovenum == -1) {
                                        /* TODO: Use this info somehow */
                                        String move = yytext();
                                        if (move.endsWith("."))
                                            move = move.substring(0, move.length() - 1);
                                        firstmovenum = Integer.parseInt(move);
                                        if (firstmovenum < 0 || firstmovenum > 32000)
                                            firstmovenum = -1;
                                        /* printf("First move num=%d\n", firstmovenum); */
                                    }
                                }
                                break;
                            case 42:
                                YY_RULE_SETUP();
                                // #line 368 "lexpgn.l"
                                {
                                    seen_moves = true;
                                    side = black;
                                }
                                break;
                            case 43:
                                YY_RULE_SETUP();
                                // #line 371 "lexpgn.l"
                                { /* Process a move */
                                    seen_moves = true;
                                    if (data_dest != DEST_TRASH) {
                                        /*  printf("Seen move %s\n", yytext); */
                                        /* SAN moves can be at most 7 characters, and
                                          Game[].SANmv must be able to store the result. */
                                        if (yyleng > 7) {
                                            System.out.println("Error: move too long: " + yytext());
                                            return 1;
                                        }
                                        p = Move.ValidateMove(yytext());
                                        if (p < 0) {
                                            System.out.println("Illegal move: " + yytext());
                                            return 1;
                                        }
                                        /* MakeMove increments GameCnt */
                                        Move.MakeMove(side, Tree[p].move);
                                        if (addtobook[side]) {
                                            if (Book.BookBuilder(result, side) == BOOK_EFULL) {
                                                System.out.println("Book full - Failed to add move " +
                                                        yytext());
                                                Output.ShowBoard();
                                                return 1;
                                            }

                                        }
                                        Game[GameCnt].SANmv = yytext();
                                        side = 1 ^ side;
                                    }
                                }
                                break;
                            case 44:
                                YY_RULE_SETUP();
                                // #line 402 "lexpgn.l"
                                {
                                    rav_count = 1;
                                    append_comment(yytext());
                                    BEGIN(RAV);
                                }
                                break;
                            case 45:
                                YY_RULE_SETUP();
                                // #line 403 "lexpgn.l"
                                {
                                    rav_count++;
                                    append_comment(yytext());
                                }
                                break;
                            case 46:
                                YY_RULE_SETUP();
                                // #line 404 "lexpgn.l"
                                {
                                    rav_count--;
                                    append_comment(yytext());
                                    if (rav_count <= 0) BEGIN(INITIAL);
                                }
                                break;
                            case 47:
                                YY_RULE_SETUP();
                                // #line 406 "lexpgn.l"
                                {
                                    append_comment(yytext());
                                    /* We escape [ to avoid problems with
                                       unclosed RAV */
                                }
                                break;
                            case 48:
                                YY_RULE_SETUP();
                                // #line 410 "lexpgn.l"
                                {
                                    yyless(yy_bp, yy_cp, 0);
                                    BEGIN(INITIAL);
                                    return (0); /* Damn humans */
                                }
//                                break;
                            case 49:
                                YY_RULE_SETUP();
                                // #line 411 "lexpgn.l"
                                { append_comment(yytext()); }
                                break;
                            case 50:
                                YY_RULE_SETUP();
                                // #line 414 "lexpgn.l"
                                {
                                    System.out.println("Illegal character '" + bufchar(yytext_ptr) + "' in input stream.");
                                    return 1;
                                }
//                                break;
                            case 51:
                                YY_RULE_SETUP();
                                // #line 419 "lexpgn.l"
                                ECHO();
                                break;
                                // #line 2504 "lexpgn.c"
                            case YY_END_OF_BUFFER + INITIAL + 1:    // YY_STATE_EOF(INITIAL):
                            case YY_END_OF_BUFFER + tag_gobble + 1:    // YY_STATE_EOF(tag_gobble):
                            case YY_END_OF_BUFFER + tagsymbol + 1:    // YY_STATE_EOF(tagsymbol):
                            case YY_END_OF_BUFFER + tagsep + 1:    // YY_STATE_EOF(tagsep):
                            case YY_END_OF_BUFFER + tagdata + 1:    // YY_STATE_EOF(tagdata):
                            case YY_END_OF_BUFFER + tagend + 1:    // YY_STATE_EOF(tagend):
                            case YY_END_OF_BUFFER + bracecomment + 1:    // YY_STATE_EOF(bracecomment):
                            case YY_END_OF_BUFFER + RAV + 1:    // YY_STATE_EOF(RAV):
                                //yyterminate();
                                if (seen_tags || seen_moves) return 1;
                                return 2;
                            case YY_END_OF_BUFFER:
                                {
                                    /* Amount of text matched not including the EOB char. */
                                    int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

                                    /* Undo the effects of YY_DO_BEFORE_ACTION. */
//            yytext[yy_cp] = yy_hold_char;
                                    YY_RESTORE_YY_MORE_OFFSET();

                                    if (yy_current_buffer.yy_buffer_status == YY_BUFFER_NEW) {
                                        /* We're scanning a new file or input source.  It's
                                         * possible that this happened because the user
                                         * just pointed yyin at a new source and called
                                         * yylex().  If so, then we have to assure
                                         * consistency between yy_current_buffer and our
                                         * globals.  Here is the right place to do so, because
                                         * this is the first action (other than possibly a
                                         * back-up) that will match for the new input source.
                                         */
                                        yy_n_chars = yy_current_buffer.yy_n_chars;
                                        yy_current_buffer.yy_input_file = yyin;
                                        yy_current_buffer.yy_buffer_status = YY_BUFFER_NORMAL;
                                    }

                                    /* Note that here we test for yy_c_buf_p "<=" to the position
                                     * of the first EOB in the buffer, since yy_c_buf_p will
                                     * already have been incremented past the NUL character
                                     * (since all states make transitions on EOB to the
                                     * end-of-buffer state).  Contrast this with the test
                                     * in input().
                                     */
                                    //  if ( yy_c_buf_p <= &yy_current_buffer.yy_ch_buf[yy_n_chars] )
                                    if (yy_c_buf_p <= yy_n_chars) { /* This was really a NUL. */
                                        /*yy_state_type*/ int yy_next_state;

                                        yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

                                        yy_current_state = yy_get_previous_state();

                                        /* Okay, we're now positioned to make the NUL
                                         * transition.  We couldn't have
                                         * yy_get_previous_state() go ahead and do it
                                         * for us because it doesn't know how to deal
                                         * with the possibility of jamming (and we don't
                                         * want to build jamming into it because then it
                                         * will run more slowly).
                                         */

                                        yy_next_state = yy_try_NUL_trans(yy_current_state);

                                        yy_bp = yytext_ptr + YY_MORE_ADJ;

                                        if (yy_next_state != 0) {
                                            /* Consume the NUL. */
                                            yy_cp = ++yy_c_buf_p;
                                            yy_current_state = yy_next_state;
                                            continue yy_match;
                                        } else {
                                            yy_cp = yy_c_buf_p;
                                            continue yy_find_action;
                                        }
                                    } else
                                        switch (yy_get_next_buffer()) {
                                            case EOB_ACT_END_OF_FILE:
                                                {
                                                    yy_did_buffer_switch_on_eof = false;

                                                    if (yywrap()) {
                                                        /* Note: because we've taken care in
                                                         * yy_get_next_buffer() to have set up
                                                         * yytext, we can now set up
                                                         * yy_c_buf_p so that if some total
                                                         * hoser (like flex itself) wants to
                                                         * call the scanner after we return the
                                                         * YY_NULL, it'll still work - another
                                                         * YY_NULL will get returned.
                                                         */
                                                        yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

                                                        yy_act = YY_STATE_EOF(YY_START());
                                                        continue do_action;
                                                    } else {
                                                        if (!yy_did_buffer_switch_on_eof)
                                                            YY_NEW_FILE();
                                                    }
                                                    break;
                                                }

                                            case EOB_ACT_CONTINUE_SCAN:
                                                yy_c_buf_p =
                                                        yytext_ptr + yy_amount_of_matched_text;

                                                yy_current_state = yy_get_previous_state();

                                                yy_cp = yy_c_buf_p;
                                                yy_bp = yytext_ptr + YY_MORE_ADJ;
                                                continue yy_match;

                                            case EOB_ACT_LAST_MATCH:
                                                yy_c_buf_p = yy_n_chars;

                                                yy_current_state = yy_get_previous_state();

                                                yy_cp = yy_c_buf_p;
                                                yy_bp = yytext_ptr + YY_MORE_ADJ;
                                                continue yy_find_action;
                                        }
                                    break;
                                }

                            default:
                                YY_FATAL_ERROR("fatal flex scanner internal error--no action found");
                        } /* end of action switch */
                        break;
                    } // end of findAction
                    break;
                } // end of doAction loop
                break;
            } // end of match loop
        } /* end of scanning one token */
    } /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

    static int yy_get_next_buffer() {
        int dest = 0;
        int source = yytext_ptr;
        int number_to_move, i;
        int ret_val;

        if (yy_c_buf_p > yy_n_chars + 1)
            YY_FATAL_ERROR("fatal flex scanner internal error--end of buffer missed");

        if (!yy_current_buffer.yy_fill_buffer) { /* Don't try to fill the buffer, so this is an EOF. */
            if (yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1) {
                /* We matched a single character, the EOB, so
                 * treat this as a final EOF.
                 */
                return EOB_ACT_END_OF_FILE;
            } else {
                /* We matched some text prior to the EOB, first
                 * process it.
                 */
                return EOB_ACT_LAST_MATCH;
            }
        }

        /* Try to read more data. */

        /* First move last chars to start of buffer. */
        number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

        for (i = 0; i < number_to_move; ++i)
            yy_current_buffer.yy_ch_buf[dest++] = yy_current_buffer.yy_ch_buf[source++];

        if (yy_current_buffer.yy_buffer_status == YY_BUFFER_EOF_PENDING)
        /* don't do the read, it's not guaranteed to return an EOF,
         * just force an EOF
         */
            yy_current_buffer.yy_n_chars = yy_n_chars = 0;

        else {
            int num_to_read =
                    yy_current_buffer.yy_buf_size - number_to_move - 1;

            while (num_to_read <= 0) { /* Not enough room in the buffer - grow it. */
                /* just a shorter name for the current buffer */
                YY_BUFFER_STATE b = yy_current_buffer;

                int yy_c_buf_p_offset = yy_c_buf_p;

                if (b.yy_is_our_buffer) {
                    int new_size = b.yy_buf_size * 2;

                    if (new_size <= 0)
                        b.yy_buf_size += b.yy_buf_size / 8;
                    else
                        b.yy_buf_size *= 2;

                    char[] t = new char[b.yy_buf_size + 2];
                    for (int j = 0; j < b.yy_ch_buf.length; j++) {
                        t[j] = b.yy_ch_buf[j];
                    }
                    b.yy_ch_buf = t;
                    /* Include room in for 2 EOB chars. */
//                        yy_flex_realloc( b.yy_ch_buf, b.yy_buf_size + 2 );
                } else
                /* Can't grow it, we don't own it. */
                    b.yy_ch_buf = null;

                if (b.yy_ch_buf == null)
                    YY_FATAL_ERROR("fatal error - scanner input buffer overflow");

                yy_c_buf_p = yy_c_buf_p_offset;

                num_to_read = yy_current_buffer.yy_buf_size -
                        number_to_move - 1;
            }

            if (num_to_read > YY_READ_BUF_SIZE)
                num_to_read = YY_READ_BUF_SIZE;

            /* Read in more data. */
            yy_n_chars = YY_INPUT(number_to_move, num_to_read);

            yy_current_buffer.yy_n_chars = yy_n_chars;
        }

        if (yy_n_chars == 0) {
            if (number_to_move == YY_MORE_ADJ) {
                ret_val = EOB_ACT_END_OF_FILE;
                yyrestart(yyin);
            } else {
                ret_val = EOB_ACT_LAST_MATCH;
                yy_current_buffer.yy_buffer_status =
                        YY_BUFFER_EOF_PENDING;
            }
        } else
            ret_val = EOB_ACT_CONTINUE_SCAN;

        yy_n_chars += number_to_move;
        yy_current_buffer.yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
        yy_current_buffer.yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

        yytext_ptr = 0;

        return ret_val;
    }


/* yy_get_previous_state - get the state just before the EOB char was reached */

    static /*yy_state_type*/ int yy_get_previous_state() {
        /*yy_state_type*/ int yy_current_state;
        int yy_cp;

        yy_current_state = yy_start;
        yy_current_state += YY_AT_BOL() ? 1 : 0;

        for (yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp) {

            char c = bufchar(yy_cp);
            if (yy_cp == yytext_ptr + yyleng)
                c = 0;  // c version doesn't do this because it bangs 0 into the buffer
            yy_current_state = yy_nxt[yy_current_state][( c != 0 ? yy_ec[YY_SC_TO_UI(c)] : 1)];
            if (yy_accept[yy_current_state] != 0) {
                yy_last_accepting_state = yy_current_state;
                yy_last_accepting_cpos = yy_cp;
            }
        }

        return yy_current_state;
    }


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

    static /*yy_state_type*/ int yy_try_NUL_trans(/*yy_state_type*/ int yy_current_state) {
        boolean yy_is_jam;
        int yy_cp = yy_c_buf_p;

        yy_current_state = yy_nxt[yy_current_state][1];
        yy_is_jam = (yy_current_state <= 0);

        if (!yy_is_jam) {
            if (yy_accept[yy_current_state] != 0) {
                yy_last_accepting_state = yy_current_state;
                yy_last_accepting_cpos = yy_cp;
            }
        }

        return yy_is_jam ? 0 : yy_current_state;
    }


    ///#ifndef YY_NO_UNPUT

    static void yyunput(int c, int yy_bp) {
        int yy_cp = yy_c_buf_p;

        /* undo effects of setting up yytext */
//        yytext[yy_cp] = yy_hold_char;

        if (yy_cp < 2) { /* need to shift things up to make room */
            /* +2 for EOB chars. */
            int number_to_move = yy_n_chars + 2;
            int dest = yy_current_buffer.yy_buf_size + 2;
            int source = number_to_move;

            while (source > 0)
                yy_current_buffer.yy_ch_buf[--dest] = yy_current_buffer.yy_ch_buf[--source];

            yy_cp += (int) (dest - source);
            yy_bp += (int) (dest - source);
            yy_current_buffer.yy_n_chars =
                    yy_n_chars = yy_current_buffer.yy_buf_size;

            if (yy_cp < 2)
                YY_FATAL_ERROR("flex scanner push-back overflow");
        }

        yy_current_buffer.yy_ch_buf[--yy_cp] = (char) c;


        yytext_ptr = yy_bp;
//        yy_hold_char = yy_current_buffer.yy_ch_buf[yy_cp];
        yy_c_buf_p = yy_cp;
    }
    ///#endif	/* ifndef YY_NO_UNPUT */



    static int yyinput() {
        int c;

//        yytext[yy_c_buf_p] = yy_hold_char;

        if (yy_current_buffer.yy_ch_buf[yy_c_buf_p] == YY_END_OF_BUFFER_CHAR) {
            /* yy_c_buf_p now points to the character we want to return.
             * If this occurs *before* the EOB characters, then it's a
             * valid NUL; if not, then we've hit the end of the buffer.
             */
            if (yy_c_buf_p < yy_n_chars)
            /* This was really a NUL. */
                yy_current_buffer.yy_ch_buf[yy_c_buf_p] = '\0';

            else { /* need more input */
                int offset = yy_c_buf_p - yytext_ptr;
                ++yy_c_buf_p;

                switch (yy_get_next_buffer()) {
                    case EOB_ACT_LAST_MATCH:
                        /* This happens because yy_g_n_b()
                         * sees that we've accumulated a
                         * token and flags that we need to
                         * try matching the token before
                         * proceeding.  But for input(),
                         * there's no matching to consider.
                         * So convert the EOB_ACT_LAST_MATCH
                         * to EOB_ACT_END_OF_FILE.
                         */

                        /* Reset buffer status. */
                        yyrestart(yyin);

                        /* fall through */

                    case EOB_ACT_END_OF_FILE:
                        {
                            if (yywrap())
                                return EOF;

                            if (!yy_did_buffer_switch_on_eof)
                                YY_NEW_FILE();
                            return yyinput();
                        }

                    case EOB_ACT_CONTINUE_SCAN:
                        yy_c_buf_p = yytext_ptr + offset;
                        break;
                }
            }
        }

        c = yy_current_buffer.yy_ch_buf[yy_c_buf_p];
//        *yy_c_buf_p = '\0';	/* preserve yytext */
//        yy_hold_char = *++yy_c_buf_p;

        yy_current_buffer.yy_at_bol = (c == '\n');

        return c;
    }


    static void yyrestart(Reader input_file) {
        if (yy_current_buffer == null)
            yy_current_buffer = yy_create_buffer(yyin, YY_BUF_SIZE);

        yy_init_buffer(yy_current_buffer, input_file);
        yy_load_buffer_state();
    }


    void yy_switch_to_buffer(YY_BUFFER_STATE new_buffer) {
        if (yy_current_buffer == new_buffer)
            return;

        if (yy_current_buffer != null) {
            /* Flush out information for old buffer. */
//            *yy_c_buf_p = yy_hold_char;
            yy_current_buffer.yy_buf_pos = yy_c_buf_p;
            yy_current_buffer.yy_n_chars = yy_n_chars;
        }

        yy_current_buffer = new_buffer;
        yy_load_buffer_state();

        /* We don't actually know whether we did this switch during
         * EOF (yywrap()) processing, but the only time this flag
         * is looked at is after yywrap() is called, so it's safe
         * to go ahead and always set it.
         */
        yy_did_buffer_switch_on_eof = true;
    }


    static void yy_load_buffer_state() {
        yy_n_chars = yy_current_buffer.yy_n_chars;
        yytext_ptr = yy_c_buf_p = yy_current_buffer.yy_buf_pos;
        yyin = yy_current_buffer.yy_input_file;
//        yy_hold_char = *yy_c_buf_p;
    }


    static YY_BUFFER_STATE yy_create_buffer(Reader file, int size) {
        YY_BUFFER_STATE b;

        b = new YY_BUFFER_STATE();

        b.yy_buf_size = size;

        /* yy_ch_buf has to be 2 characters longer than the size given because
         * we need to put in 2 end-of-buffer characters.
         */
        b.yy_ch_buf = new char[b.yy_buf_size + 2];

        b.yy_is_our_buffer = true;

        yy_init_buffer(b, file);

        return b;
    }


    static void yy_delete_buffer(YY_BUFFER_STATE b) {
        if (b == null)
            return;

        if (b == yy_current_buffer)
            yy_current_buffer = null;

    }


    static void yy_init_buffer(YY_BUFFER_STATE b, Reader file) {
        yy_flush_buffer(b);

        b.yy_input_file = file;
        b.yy_fill_buffer = true;


        //fixjava rely on callers to set interactive state
        // b.yy_is_interactive = file != null ? (isatty(fileno(file)) > 0) : false;

    }


    static void yy_flush_buffer(YY_BUFFER_STATE b) {
        if (b == null)
            return;

        b.yy_n_chars = 0;

        /* We always need two end-of-buffer characters.  The first causes
         * a transition to the end-of-buffer state.  The second causes
         * a jam in that state.
         */
        b.yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
        b.yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

        b.yy_buf_pos = 0;   // was &b.yy_ch_buf[0];

        b.yy_at_bol = true;
        b.yy_buffer_status = YY_BUFFER_NEW;

        if (b == yy_current_buffer)
            yy_load_buffer_state();
    }

/*
    ///#ifndef YY_NO_SCAN_BUFFER

     static YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )

        {
        YY_BUFFER_STATE b;

        if ( size < 2 ||
             base[size-2] != YY_END_OF_BUFFER_CHAR ||
             base[size-1] != YY_END_OF_BUFFER_CHAR )
/          //  They forgot to leave room for the EOB's.
            return 0;

        b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( YY_BUFFER_STATE ) );
        if ( ! b )
            YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

        b.yy_buf_size = size - 2;	// "- 2" to take care of EOB's
        b.yy_buf_pos = b.yy_ch_buf = base;
        b.yy_is_our_buffer = 0;
        b.yy_input_file = 0;
        b.yy_n_chars = b.yy_buf_size;
        b.yy_is_interactive = 0;
        b.yy_at_bol = 1;
        b.yy_fill_buffer = 0;
        b.yy_buffer_status = YY_BUFFER_NEW;

        yy_switch_to_buffer( b );

        return b;
        }
    ///#endif


    ///#ifndef YY_NO_SCAN_STRING
    static  YY_BUFFER_STATE yy_scan_string( String yy_str )

        {
        int len;
        for ( len = 0; yy_str[len]; ++len )
            ;

        return yy_scan_bytes( yy_str, len );
        }
    ///#endif


    ///#ifndef YY_NO_SCAN_BYTES
    static  YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )

        {
        YY_BUFFER_STATE b;
        char *buf;
        yy_size_t n;
        int i;

        // Get memory for full buffer, including space for trailing EOB's.
        n = len + 2;
        buf = (char *) yy_flex_alloc( n );
        if ( ! buf )
            YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

        for ( i = 0; i < len; ++i )
            buf[i] = bytes[i];

        buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

        b = yy_scan_buffer( buf, n );
        if ( ! b )
            YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

        // It's okay to grow etc. this buffer, and we should throw it
        // away when we're done.
        b.yy_is_our_buffer = 1;

        return b;
        }
    ///#endif
*/
    static final int YY_EXIT_FAILURE = 2;


    static void yy_fatal_error(String msg) {
        System.err.println(msg);
        System.exit(YY_EXIT_FAILURE);
    }

    static char bufchar(int i) {
        return YY_CURRENT_BUFFER().yy_ch_buf[i];
    }

    static String yytext() {
        return new String(YY_CURRENT_BUFFER().yy_ch_buf, yytext_ptr, yyleng);
    }
}
