/* This file is part of chessbox_gnu4j, a Java port of GNU Chess (5.0.7).

   Copyright (c) 2005 Xan Gregg (Java port)
   Copyright (c) 1999-2002 Free Software Foundation, Inc.

   chessbox_gnu4j is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 or (at your option)
   any later version.

   chessbox_gnu4j is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Chess; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info:
     bug-gnu-chess@gnu.org
     xan.gregg@pobox.com
*/
package org.chessbox.gnu4j;

/**
 * Created by Xan Gregg.
 * Date: May 8, 2005
 */
public class Null extends Common {

    /**
     * Makes a null move on the board and update the various game information.
     */
    static void MakeNullMove(int side) {
        GameRec g;

        GameCnt++;
        g = Game[GameCnt];
        g.epsq = board.ep;
        g.bflag = board.flag;
        g.hashkey = HashKey;
        if (board.ep > -1)
            HashKey ^= ephash[board.ep];
        HashKey ^= Sidehash;
        board.ep = -1;
        board.side = (short) (1 ^ side);

        /* Update game record */
        g.move = NULLMOVE;
        return;
    }


    /**
     * Undoes a null move.
     */
    static void UnmakeNullMove(int side) {
        GameRec g;

        side = 1 ^ side;
        board.side = (short) side;
        g = Game[GameCnt];
        board.ep = g.epsq;
        board.flag = g.bflag;
        HashKey = g.hashkey;
        GameCnt--;
        return;
    }
}
