/* This file is part of chessbox_gnu4j, a Java port of GNU Chess (5.0.7).

   Copyright (c) 2005 Xan Gregg (Java port)
   Copyright (c) 1999-2002 Free Software Foundation, Inc.

   chessbox_gnu4j is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 or (at your option)
   any later version.

   chessbox_gnu4j is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Chess; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info:
     bug-gnu-chess@gnu.org
     xan.gregg@pobox.com
*/
package org.chessbox.gnu4j;

/**
 * Created by Xan Gregg.
 * Date: May 8, 2005
 */
public class Ponder extends Common {

/*
 * Pondering has to check for input_status == INPUT_NONE regularly,
 * that is what Iterate() is supposed to do when the PONDER flag is
 * set.  Output should only be generated if the xboard flag is
 * set. (Otherwise stdout gets messed up.)
 */

    static void ponder() {
        /* Save flags and clear the time control bit for pondering */
        final int saved_flags = flags;

        /* Save number of moves out of book */
        final int nmfb = nmovesfrombook;

        ClearFlag(TIMECTL);
        SetFlag(PONDER);

        Debug.dbg_printf("Pondering, GameCnt = " + GameCnt);
        Iterate.Iterate();
        Debug.dbg_printf("Pondering ended, GameCnt = " + GameCnt);

        /* Restore flags, will also clear the PONDER flag */
        flags = saved_flags;

        nmovesfrombook = nmfb;
    }
}
