/* This file is part of chessbox_gnu4j, a Java port of GNU Chess (5.0.7).

   Copyright (c) 2005 Xan Gregg (Java port)
   Copyright (c) 1999-2002 Free Software Foundation, Inc.

   chessbox_gnu4j is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 or (at your option)
   any later version.

   chessbox_gnu4j is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Chess; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info:
     bug-gnu-chess@gnu.org
     xan.gregg@pobox.com
*/
package org.chessbox.gnu4j;

/**
 * Created by Xan Gregg.
 * Date: May 25, 2005
 */
public class Random {
/*
 *  Random numbers from Mathematica 2.0
 *  SeedRandom = 1;
 *  Table[Random[Integer, {0, 2^32 - 1}]
 */
    static int[] x =
            {
                (int) 1410651636L,
                (int) 3012776752L,
                (int) 3497475623L,
                (int) 2892145026L,
                (int) 1571949714L,
                (int) 3253082284L,
                (int) 3489895018L,
                (int) 387949491L,
                (int) 2597396737L,
                (int) 1981903553L,
                (int) 3160251843L,
                (int) 129444464L,
                (int) 1851443344L,
                (int) 4156445905L,
                (int) 224604922L,
                (int) 1455067070L,
                (int) 3953493484L,
                (int) 1460937157L,
                (int) 2528362617L,
                (int) 317430674L,
                (int) 3229354360L,
                (int) 117491133L,
                (int) 832845075L,
                (int) 1961600170L,
                (int) 1321557429L,
                (int) 747750121L,
                (int) 545747446L,
                (int) 810476036L,
                (int) 503334515L,
                (int) 4088144633L,
                (int) 2824216555L,
                (int) 3738252341L,
                (int) 3493754131L,
                (int) 3672533954L,
                (int) 29494241L,
                (int) 1180928407L,
                (int) 4213624418L,
                (int) 33062851L,
                (int) 3221315737L,
                (int) 1145213552L,
                (int) 2957984897L,
                (int) 4078668503L,
                (int) 2262661702L,
                (int) 65478801L,
                (int) 2527208841L,
                (int) 1960622036L,
                (int) 315685891L,
                (int) 1196037864L,
                (int) 804614524L,
                (int) 1421733266L,
                (int) 2017105031L,
                (int) 3882325900L,
                (int) 810735053L,
                (int) 384606609L,
                (int) 2393861397L
            };
    static boolean init = true;
    static int[] y = new int[55];
    static int j
    ,
    k;

    /**
     * A 32 bit random number generator.  An implementation in C of the
     * algorithm given by Knuth, the art of computer programming, vol. 2,
     * pp. 26-27.  We use e=32, so we have to evaluate y(n) = y(n-24) + y(n-55)
     * mod 2^32, which is implicitly done by unsigned arithmetic.
     */
    static int Rand32() {

        int ul;

        if (init) {
            int i;
            init = false;
            for (i = 0; i < 55; i++)
                y[i] = x[i];
            j = 24 - 1;
            k = 55 - 1;
        }
        ul = (y[k] += y[j]);
        if (--j < 0) j = 55 - 1;
        if (--k < 0) k = 55 - 1;
        return (ul);
    }

    static /*HashType*/long Rand64() {
        /*HashType*/long b;

        b = Rand32();
        b = b << 32;
        b |= (Rand32() & 0xFFFFFFFFL);
        return (b);
    }

}
