/* This file is part of chessbox_gnu4j, a Java port of GNU Chess (5.0.7).

   Copyright (c) 2005 Xan Gregg (Java port)
   Copyright (c) 1999-2002 Free Software Foundation, Inc.

   chessbox_gnu4j is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 or (at your option)
   any later version.

   chessbox_gnu4j is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Chess; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info:
     bug-gnu-chess@gnu.org
     xan.gregg@pobox.com
*/
package org.chessbox.gnu4j;

import java.util.StringTokenizer;
@SuppressWarnings("all")
/**
 * Created by Xan Gregg.
 * Date: May 9, 2005
 */
public class Solve extends Common {
    static void Solve(String file) {
        int total, correct;
        boolean found;
        long TotalNodes;

        total = correct = 0;
        TotalNodes = 0;
        SetFlag(SOLVE);
        while (EPD.ReadEPDFile(file, 0)) {
            Init.NewPosition();
            total++;
            Output.ShowBoard();
            Iterate.Iterate();
            TotalNodes += NodeCnt + QuiesCnt;
            found = false;
            for (StringTokenizer st = new StringTokenizer(solution); st.hasMoreTokens();) {
                String s = st.nextToken();
                if (s.startsWith(SANmv))   // fixc use equality
                {
                    correct++;
                    found = true;
                    break;
                }
            }
            System.out.print(id + " : ");
            System.out.print(found ? "Correct:  " : "Incorrect:  ");
            System.out.println(SANmv + " " + solution);
            System.out.println("Correct=" + correct + " Total=" + total);
        }
        System.out.println("\nTotal nodes = " + TotalNodes);
        ClearFlag(SOLVE);
    }


}
